﻿
// Shaking SolutionDlg.cpp : 实现文件
//

#include "stdafx.h"
#include "Shaking Solution.h"
#include "Shaking SolutionDlg.h"
#include "afxdialogex.h"
#include <opencv2\core\core.hpp>
#include <opencv2\highgui\highgui.hpp>
//打印需要的
#include <io.h>//Rain  用来输出调试信息
#include <fcntl.h>//Rain
//matlab 
//#include "engine.h";
//#include<mex.h>
//
//#pragma comment( lib, "libeng.lib" )
//#pragma comment( lib, "libmx.lib" )
//#pragma comment( lib, "libmat.lib" )

using namespace std;
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

int MAX_INT=1000000;

void InitConsoleWindow()//在OnInitDialog中调用
{
	int nCrt = 0;
	FILE* fp;
	AllocConsole();
	nCrt = _open_osfhandle((long)GetStdHandle(STD_OUTPUT_HANDLE), _O_TEXT);
	fp = _fdopen(nCrt, "w");
	*stdout = *fp;
	setvbuf(stdout, NULL, _IONBF, 0);
}

// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	// 对话框数据
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

	// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// CShakingSolutionDlg 对话框

CShakingSolutionDlg::CShakingSolutionDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CShakingSolutionDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CShakingSolutionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CShakingSolutionDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_STN_CLICKED(IDS_ABOUTBOX, &CShakingSolutionDlg::OnStnClickedAboutbox)
	ON_BN_CLICKED(IDC_ShowFrame, &CShakingSolutionDlg::OnBnClickedShowframe)
	ON_BN_CLICKED(IDC_STOP, &CShakingSolutionDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_OpenVideo, &CShakingSolutionDlg::OnBnClickedOpenvideo)
	ON_BN_CLICKED(IDC_grabCut, &CShakingSolutionDlg::OnBnClickedgrabcut)
	ON_BN_CLICKED(IDC_Me, &CShakingSolutionDlg::OnBnClickedMe)
END_MESSAGE_MAP()

// CShakingSolutionDlg 消息处理程序

BOOL CShakingSolutionDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	InitConsoleWindow();//Rain
	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CShakingSolutionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CShakingSolutionDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CShakingSolutionDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

int* findGoodFeature(CvPoint2D32f* previous,CvPoint2D32f* current,int count){
	/*
	int static index[500];
	int counter=0;
	for(int i=0;i<count;i++){
	double dx=previous[i].x-current[i].x;
	double dy=previous[i].y-current[i].y;
	if(dx<10 && dy<10){
	index[++counter]=i;
	}	
	}
	index[0]=counter;
	return index;
	*/
	/*
	int counter=0;
	static int index[500];
	int i=0,j=0;
	//cout<<"fffff"<<current[8].x<<"   "<<current[8].y<<endl;
	bool flag;
	double record=0,err=0;
	while(j<count){
	flag=TRUE;
	for(i=j;i<count;i++){
	double dx=previous[i].x-current[i].x;
	double dy=previous[i].y-current[i].y;
	cout<<"dx"<<dx<<" "<<"dy"<<dy<<endl;
	dx*=100;dy*=100;
	if(dx!=0){
	if(flag){
	record=dy/dx;
	flag=FALSE;
	}
	err=dy/dx;

	if(abs(err-record)/abs(record)<0.2){
	index[counter]=i;					
	//cout<<index[counter]<<" "<<endl;
	counter++;
	}
	}

	if(dx==0){
	//cout<<"dx===========0"<<endl;
	index[counter]=i;
	counter++;
	}
	}

	if(counter>=0.8*count){
	index[0]=counter-1;
	return index;
	}
	j++;
	}
	*/		


	int static index[2];

	index[0]=1;
	index[1]=20;
	return index;

}

Mat adjustFrame(IplImage* frame_camera,double dx,double dy){
	int delx=(int)dx;int dely=(int)dy;

	Mat mat(frame_camera,CV_8UC3);

	//imshow("mat",mat);
	Mat temp=Mat(mat.rows,mat.cols,CV_8UC3);
	for(int i=0;i<temp.rows;i++)
		for(int j=0;j<temp.cols;j++)
			temp.at<Vec3b>(i,j)=mat.at<Vec3b>(50,40);

	for(int i=0;i<mat.rows;i++)
		for(int j=0;j<mat.cols;j++){
			if( (i+dely)>0 && (i+dely)<mat.rows && (j+delx)>0 && (j+delx)<mat.cols){
				Vec3i s=mat.at<Vec3b>(i,j);   //数据访问
				//cout<<s.val[0]<<"  "<<s.val[1]<<"  "<<s.val[2]<<endl;
				temp.at<Vec3b>(i+dely,j+delx)=s;
			}	 
		}
		//边框变黑
	//for(int i=0;i<20;i++)
	//	for(int j=0;j<temp.cols;j++){
	//		temp.at<Vec3b>(i,j)=0;
	//		temp.at<Vec3b>(temp.rows-i,j)=0;
	//	}
	//for(int i=0;i<temp.rows;i++)
	//	for(int j=0;j<20;j++){
	//		temp.at<Vec3b>(i,j)=0;
	//		temp.at<Vec3b>(i,temp.cols-j)=0;
	//	}
		return temp;
		//Mat M;
		//IplImage iplimage = M;

		//对于单通道字节型图像: 
		//IplImage* img=cvCreateImage(cvSize(640,480),IPL_DEPTH_8U,1); 
		//CvScalar s; 
		//s=cvGet2D(img,i,j);
		// get the (i,j) pixel value printf("intensity=%f\n",s.val[0]); s.val[0]=111; 
		//cvSet2D(img,i,j,s);
		// set the (i,j) pixel value  	 
		//对于多通道字节型/浮点型图像: 
		//printf("size of frame_camera%d  %d \n",(*frame_camera)->width,(*frame_camera)->height);
		//img=cvCreateImage(cvGetSize(*frame_camera),IPL_DEPTH_32F,3);
		//CvScalar s;
		//printf("frame_camera size%d  %d");
		/*
		for( int y=0; y<img->height; y++ ) { 
		        uchar* ptr = (uchar*) (img->imageData + y * img->widthStep); 
				        for( int x=0; x<img->width; x++ ) {             
						ptr[3*x+1] = 255;             
						ptr[3*x+2] = 255;         
						}     
						} 
						*/
		/*
		for(int i=1;i<(*frame_camera)->height;i++)
		for(int j=1;j<(*frame_camera)->width;j++){
		s=cvGet2D(*frame_camera,i,j);	// get the (i,j) pixel value 
		//printf("B=%f, G=%f, R=%f\n",s.val[0],s.val[1],s.val[2]); 
		s.val[0]=111;s.val[1]=111;s.val[3]=111;
		cvSet2D(img,i,j,s);

		}
		//cvNamedWindow("adjust");
		//cvShowImage("adjust",*frame_camera);
		*frame_camera=img;

		cvReleaseImage(&img);
		*/
}

double calcAngle(CvPoint2D32f center, CvPoint2D32f a, CvPoint2D32f b){

	const double M_PI = 3.1415926535897 ; 
	double ma_x = a.x - center.x; 
	double ma_y = a.y - center.y; 
	double mb_x = b.x - center.x; 
	double mb_y = b.y - center.y; 
	double v1 = (ma_x * mb_x) + (ma_y * mb_y); 
	
	double ma_val = sqrt(ma_x * ma_x + ma_y * ma_y); 
	double mb_val = sqrt(mb_x * mb_x + mb_y * mb_y); 
	double cosM = v1 / (ma_val * mb_val); 
	//cout<<"v1  "<<center.x<<endl;
	double angleAMB = acos(cosM) * 180 / M_PI;  
	

	return angleAMB;
}

void on_mouse( int event, int x, int y, int flags, void* param )
{

	CvPoint  pt;
	// if( image->origin )
	//     y = image->height - y;

	if( event == CV_EVENT_LBUTTONDOWN )
	{
		pt = cvPoint(x,y);
		cout<<"click point:"<<x<<"  "<<y<<endl;
		// add_remove_pt = 1;
	}
}

vector<int> find4Feature(IplImage* frame_camera,CvPoint2D32f* points,int count){
	vector<int> features;
	Mat mat(frame_camera);
	int px,py;
	for(int i=0;i<count;i++){
		py=(int)points[i].x;
		px=(int)points[i].y;
		if(px >= 0&& py >= 0)
		{
			Vec3b s=mat.at<Vec3b>(px,py);

			//第一帧的特征点位置 查找和匹配 points每个点判断  像素值满足条件 并且位于四个位置其中之一
			//1/4范围内有特征点  B G R

			/*if(( (int)s[0]<60 && (int)s[1]<60 && (int)s[2]<60 &&(px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) || 
				(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols) || 
				(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4) || 
				(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols) )
				)*/

				/*
				if((int)s[0]<60 && (int)s[1]<60 && (int)s[2]<60 && ( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) || 
				(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols) || 
				(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4) || 
				(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols) )
				)

				*/
				
				/*if((int)s[0]<60 && (int)s[1]<60 && (int)s[2]<60 && ( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2) || 
				(px>0 && px<mat.rows/2 && py>mat.cols/2 && py<mat.cols) || 
				(px>mat.rows/2 && px<mat.rows && py>0 && py<mat.cols/2) || 
				(px>mat.rows/2 && px<mat.rows && py>mat.cols/2 && py<mat.cols) )
				)*/
				
				//1/4寻找
				/*
				if(( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) || 
				(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols) || 
				(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4) || 
				(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols) )
				)*/		

				//整张图像1/2寻找
				if( ( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2) || 
				(px>0 && px<mat.rows/2 && py>mat.cols/2 && py<mat.cols) || 
				(px>mat.rows/2 && px<mat.rows && py>0 && py<mat.cols/2) || 
				(px>mat.rows/2 && px<mat.rows && py>mat.cols/2 && py<mat.cols) )
				)

			{
				features.push_back(i);
				//if(features.size()==4) return features;
			}
		}//end if
	}//end for
	return features;
}

/*得到最优变换矩阵*/
Mat getTransMat(CvPoint2D32f* points0,CvPoint2D32f* points1,vector<int>& features){
	static int c = 0, c1 = 0;
	//printf("c = %d\n",c);
	vector<Point2f> vec1,vec2;
	for(int i=0;i<features.size();i++){
		//cout<<"points0 x="<<points0[features[i]].x<<endl;
		vec1.push_back(cvPointFrom32f( points0[features[i]] ));
		vec2.push_back(cvPointFrom32f( points1[features[i]] ));
	}
	Mat transform=estimateRigidTransform(vec2,vec1,false);
	//printf("c1 = %d\n",c1);
	c++;
	c1++;
	return transform;
}

IplImage* processShowframe(IplImage* image){
	Mat img(image);
	//边框变黑
	for(int i=1;i<50;i++)
		for(int j=1;j<img.cols;j++){
			img.at<Vec3b>(i,j)=0;
			img.at<Vec3b>(img.rows-i,j)=0;
		}
	for(int i=1;i<img.rows;i++)
		for(int j=1;j<50;j++){
			img.at<Vec3b>(i,j)=0;
			img.at<Vec3b>(i,img.cols-j)=0;
		}
		IplImage temp=img;
		return &temp;
		
}

void CShakingSolutionDlg::OnBnClickedShowframe()
{
	IplImage *image = 0, *featuredFrame=0,*grey = 0, *prev_grey = 0, *pyramid = 0, *prev_pyramid = 0, *swap_temp;

	int win_size = 10;
	const int MAX_COUNT = 500;
	CvPoint2D32f* points[2] = {0,0}, *swap_points, *point1pre=NULL;
	CvPoint2D32f *initpoints=NULL;
	char* status = 0;
	int count = 0;
	int need_to_init = 1;
	int night_mode = 0;
	int flags = 0;
	int add_remove_pt = 0;
	double delx=0,dely=0;//偏移向量
	vector<int> features4,reduced_features;
	vector<int>::iterator iter;
	//cvNamedWindow("original",0);
	//IplImage* bg=cvCreateImage(cvSize(GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)),IPL_DEPTH_8U,1);
	//cvNamedWindow("Adjusted",CV_WINDOW_FULLSCREEN);
	//cvShowImage("Adjusted",bg);
	IplImage* frame_camera=0;
	CvCapture* capture = 0;
	CvPoint2D32f center;
	IplImage* swap; 
	capture = cvCaptureFromCAM(0);
	if( !capture )
	{
		fprintf(stderr,"Could not initialize capturing...\n");
		return;
	}
	/*初始化写视频*/
	double fps = 20;/*cvGetCaptureProperty (
	capture,
	CV_CAP_PROP_FPS);*/

	CvSize size = cvSize((int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH),
	(int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT)
	);

	CvVideoWriter* writer1=cvCreateVideoWriter(
	"original.avi",/*filename*/
	CV_FOURCC('X','V','I','D'), fps,size,1);	// 写视频文件
	
	CvVideoWriter* writer2=cvCreateVideoWriter(
	"adjusted.avi",/*filename*/
	CV_FOURCC('X','V','I','D'), fps,size,1);	// 写视频文件
	
	//cout<<"size="<<size.height<<endl;
	//摄像头去抖操作

	for(int framecounter=0;;)
	{
		//if(framecounter>MAX_INT) framecounter=10;

		int i, k, c;

		frame_camera = cvQueryFrame( capture );
		//double height = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT);
		//double width = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH);
		//printf("height:%f  width:%f\n",height,width);  480*640
		double start=clock();

		if( !frame_camera ) break;

		if( !image )
		{
			// allocate all the buffers 

			image = cvCreateImage( cvGetSize(frame_camera), 8, 3 );
			image->origin = frame_camera->origin;
			featuredFrame = cvCreateImage( cvGetSize(frame_camera), 8, 3 );
			featuredFrame->origin = frame_camera->origin;

			grey = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			prev_grey = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			pyramid = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			prev_pyramid = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			points[0] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
			points[1] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
			status = (char*)cvAlloc(MAX_COUNT);
			flags = 0;

		}

		cvCopy( frame_camera, image, 0 );
		cvCvtColor( image, grey, CV_BGR2GRAY );
		cvCopy( frame_camera, featuredFrame, 0 );

		if( night_mode )
			cvZero( image );

		if( need_to_init )
		{
			// automatic initialization 
			IplImage* eig = cvCreateImage( cvGetSize(grey), 32, 1 );
			IplImage* temp = cvCreateImage( cvGetSize(grey), 32, 1 );
			double quality = 0.05;
			double min_distance = 10;

			count = MAX_COUNT;
			cvGoodFeaturesToTrack( grey, eig, temp, points[1], &count,
				quality, min_distance, 0, 3, 0, 0.04 );
			cvFindCornerSubPix( grey, points[1], count,
				cvSize(win_size,win_size), cvSize(-1,-1),
				cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03));
			cvReleaseImage( &eig );
			cvReleaseImage( &temp );
			//initpoints=points[1];//initalize feature points
			add_remove_pt = 0;
			need_to_init=0;
		}
		
		else if( count > 0 )
		{
			cvCalcOpticalFlowPyrLK( prev_grey, grey, prev_pyramid, pyramid,
				points[0], points[1], count, cvSize(win_size,win_size), 3, status, 0,
				cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03), flags );
			flags |= CV_LKFLOW_PYR_A_READY;


			for( i = k = 0; i < count; i++ )
			{


				if( !status[i] ){
					//points[1][i].x=0;
					//points[1][i].y=0;
					//continue;
				}

				points[1][k++] = points[1][i];

				//printf("p0[x]=%f  p0[y]=%f\n",points[0]->x,points[0]->y);
				//printf("p1[x]=%f  p1[y]=%f\n\n",points[1]->x,points[1]->y);

				//cvCircle( image, cvPointFrom32f(points[1][i]), 3, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][2]), 3, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][90]), 20, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][4]), 3, CV_RGB(0,255,0), -1, 8,0);
				//translation=calcTranslation(points,1);
				//printf("trans x=%f    trans y=%f",translation[0],translation[1]);
			}
			count = k;


			if(framecounter==1){
				features4=find4Feature(frame_camera,points[1],count);
				initpoints = new CvPoint2D32f[count];
				for(int i=0; i<count; i++){
					initpoints[i]=points[1][i];//initalize feature points
				}
				// the mouse event
				/*for(int i=0;i<features4.size();i++)
				cvCircle( image, cvPointFrom32f(points[1][features4[i]]), 3, CV_RGB(0,255,0), -1, 8,0);
				cvShowImage("original",image);
				cout<<"feature size"<<features4.size()<<endl;

				char c;
				while(1){
				cvSetMouseCallback( "original", on_mouse, 0 );
				if(27==waitKey(1))
				break;
				}*/

			}

			if(point1pre==NULL) {
				//point1pre->x=points[1]->x;
				//point1pre->y=points[1]->y; 
				point1pre=points[1];
				//printf("innitialize prex=%f  prey=%f  p1x=%f  p1y=%f\n",point1pre[20].x,point1pre[20].y,points[1][20].x,points[1][20].y);
				//printf("innitializing points previous to points[1]\n");
			}
			//if(point1pre!=NULL) {
			//	printf("points pre not null\n");
			//}

			//for(int i=0;i<count;i++){
			//delx+=point1pre[0].x-points[1][0].x;
			//dely+=point1pre[0].y-points[1][0].y;
			//}

			//int* index=findGoodFeature(point1pre,points[1],count);
			/*
			for(int i=0;i<features4.size();i++){
			cvCircle( image, cvPointFrom32f(points[1][features4[i]]), 3, CV_RGB(0,255,0), -1, 8,0);
			//	cout<<"index   "<<index[i]<<endl;
			double dx=point1pre[features4[i]].x-points[1][features4[i]].x;
			double dy=point1pre[features4[i]].y-points[1][features4[i]].y;
			if(dx<20 && dy<20){
			delx+=dx;
			dely+=dy;
			}

			else{//cannot erase for i not for iter
			//features4.erase(iter);
			cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
			if(features4.size()==0){
			cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
			return;
			}
			}
			if(iter==features4.end())break;
			//cout<<"feature "<<i<<" delx "<< point1pre[features4[i]].x-points[1][features4[i]].x<<"  dely "<<point1pre[features4[i]].y-points[1][features4[i]].y<<endl;
			}
			*/

			/*
			for(iter=features4.begin();iter != features4.end();iter++){
			cvCircle( image, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);

			//cout<<"feature point "<<*iter<<" "<<endl;

			double dx=point1pre[*iter].x-points[1][*iter].x;
			double dy=point1pre[*iter].y-points[1][*iter].y;
			if(dx<20 && dy<20){
			delx+=dx;
			dely+=dy;
			}
			else{
			features4.erase(iter);
			cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
			if(features4.size()==0){
			cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
			return;
			}
			}
			if(iter==features4.end())break;
			//cout<<"feature "<<i<<" delx "<< point1pre[features4[i]].x-points[1][features4[i]].x<<"  dely "<<point1pre[features4[i]].y-points[1][features4[i]].y<<endl;
			}
			*/

			//initial the first frame_camera's feature points and the next frames compared to the 1st
			int j=0,k =0;
			for(iter=features4.begin(),i=0,j=0,k = 0;iter != features4.end();iter++){
				
				cvCircle( featuredFrame, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);
				
				//cout<<"feature point "<<*iter<<" "<<endl;

				double dx=initpoints[*iter].x-points[1][*iter].x;
				double dy=initpoints[*iter].y-points[1][*iter].y;

				double ddx=points[0][*iter].x-points[1][*iter].x;
				double ddy=points[0][*iter].y-points[1][*iter].y;
				
				//cout<<"deltax="<<ddx<<"  deltay="<<ddy<<endl;
				if(ddx<20 || ddy<20){
					delx+=dx;
					dely+=dy;
					reduced_features.push_back(*iter);
				}
				//else{
				//	printf("i = %d\n",i);
				//	i++;
				//	features4.erase(iter);
				//	//if(iter == features4.end())
				//	
				//	//iter = features4.begin();
				//	printf("j = %d\n",j);
				//	j++;
				//	//iter++;
				//	//iter--;
				//	printf("k = %d\n",k);
				//	k++;
				//	cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
				//	if(features4.size()==0){
				//		cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
				//		return;
				//	}
				//}
				
				/*if(iter==features4.end())
					break;*/
			}

			static int s=0, s1 = 0, s2 = 0;
			//printf("s = %d\n",s);
			Mat trans_mat=getTransMat(initpoints,points[1],reduced_features);
			if(trans_mat.rows==0){
				cout<<"cannot get the transform matrix!!"<<endl<<endl;
				need_to_init=1;
				framecounter=0;
		/*		for(int i=0;i<reduced_features.size();i++){
					cout<<"initial feture points x="<<initpoints[reduced_features[i]].x<<"   y="<<initpoints[reduced_features[i]].y<<endl;
					cout<<"current feture points x="<<points[1][reduced_features[i]].x<<"   y="<<points[1][reduced_features[i]].y<<endl;
				}
				return;*/
				continue;
			}
			CvMat warp_mat = trans_mat;
			//printf("s1 = %d\n",s1);
			//printf("trans_mat's size=%d\n",trans_mat.rows);
			cvWarpAffine( frame_camera, image, &warp_mat );  //对图像做仿射变换
			//printf("s2 = %d\n",s2);
			swap = processShowframe(image);//处理边框  变为黑色
			
			reduced_features.clear();
			//cout<<"dx="<<delx<<" dy="<<dely<<endl;
			//for(int i=0;i<40;i++){
			//delx+=point1pre[20].x-points[1][20].x;
			//dely+=point1pre[20].y-points[1][20].y;
			//}

			//cout<<"delx:"<<delx<<"dely:"<<dely<<endl;
			//delete index;
			//20px is reasonable
			//printf("current feature point20 is:%f  %f\n",points[1][20].x,points[1][20].y);
			//printf("pre  feature point20 is %f  %f\n",point1pre[20].x,point1pre[20].y);
			//delx/=count;dely/=count;
			//double finish=clock();
			//printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	


		}

		//     {
		//         points[1][count++] = cvPointTo32f(pt);

		//     }
		if(count==0) need_to_init=1;

		point1pre=points[1];//记录前一帧特征点 p1信息

		CV_SWAP( prev_grey, grey, swap_temp );
		CV_SWAP( prev_pyramid, pyramid, swap_temp );
		CV_SWAP( points[0], points[1], swap_points );
		//need_to_init = 0;

		//adjust current frame_camera to erase the tremble
		//cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
		//cvShowImage("adjusted",frame_camera);
		cvShowImage("original",featuredFrame);
		//if(framecounter%2==0){
		//Mat show=adjustFrame(image,delx,dely);
		//printf("deltax=%f   deltay=%f \n",delx,dely);	
		
		//Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
		Mat show(image,CV_8UC3);

	

		//center.x=float (Img_old->width/2.0+0.5);
	//	center.y=float (Img_old->height/2.0+0.5);   
		//double angle=calcAngle
		//delx dely =0 if use the solid 1st frame_camera
		delx=0;dely=0;
		IplImage result=show;
		//printf("adjusted frame_camera%d\n",frame_camera->height);
		//cvShowImage( "LkDemo", image );
		//imshow("adjust",show);
		double finish=clock();
		//printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	

		DrawPictureToHDC(&result,IDC_ShowFrame);

		 cvWriteFrame( writer1, frame_camera );
		 cvWriteFrame( writer2, &result );
		//}


		//ShowAdjustedFrame("Adjusted",frame_camera,delx,dely );
		c = cvWaitKey(10);
		if( (char)c == 27 )
			break;
		switch( (char) c )
		{
		case 'r':
			need_to_init = 1;
			break;
		case 'c':
			count = 0;
			break;
		case 'n':
			night_mode ^= 1;
			break;
		default:
			;
		}
		framecounter++;
		//char cc=cvWaitKey(0);
		//if (cc==27){ DestroyWindow();
		//	MessageBox(_T("列表为空"),_T("警告"),MB_ICONWARNING|MB_OK);
		//}
	}//end for
	cvReleaseVideoWriter( &writer1 );
	cvReleaseVideoWriter( &writer2 );
	cvReleaseCapture( &capture );
	cvReleaseImage(&swap);
	cvReleaseImage(&frame_camera);
	cvReleaseImage(&image);
	// TODO: 在此添加控件通知处理程序代码
}

void CShakingSolutionDlg::DrawPictureToHDC(IplImage* img,UINT ID){
	CDC *pDC = GetDlgItem(ID)->GetDC();
	HDC hDC= pDC->GetSafeHdc();
	CRect rect;
	GetDlgItem(ID)->GetClientRect(&rect);
	CvvImage cimg;
	cimg.CopyOf( img ); // 复制图片
	cimg.DrawToHDC( hDC, &rect ); // 将图片绘制到显示控件的指定区域内
	ReleaseDC( pDC );
}

void CShakingSolutionDlg::OnStnClickedAboutbox()
{
	// TODO: 在此添加控件通知处理程序代码
}

void CShakingSolutionDlg::OnStnClickedShowframe()
{
	// TODO: 在此添加控件通知处理程序代码
}

void CShakingSolutionDlg::OnBnClickedStop()
{   
	DestroyWindow();
	// TODO: 在此添加控件通知处理程序代码
}

void CShakingSolutionDlg::OnBnClickedOpenvideo()
{
	cvNamedWindow("original",0);
	// TODO: Add your command handler code here
	CString FilePathName;
	char* path;
	CFileDialog dlg(TRUE, //TRUE为OPEN对话框，FALSE为SAVE AS对话框
		NULL, 
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		(LPCTSTR)_TEXT("MTS Files (*.MTS)|*.MTS|All Files (*.*)|*.*||"),
		NULL);

	if(dlg.DoModal()==IDOK)
	{
		FilePathName=dlg.GetPathName(); //文件名保存在了FilePathName里
		path=(LPSTR)(LPCTSTR)FilePathName;
		//path=FilePathName.GetBuffer(0);
		//CString strMsg=_T("当前文件打开路径为：\n")+FilePathName;//测试用的 可以删掉
		//MessageBox(strMsg);//测试用的 可以删掉
		//printf("file path%s",path);

		IplImage *image = 0, *featuredFrame=0,*grey = 0, *prev_grey = 0, *pyramid = 0, *prev_pyramid = 0, *swap_temp;
		int win_size = 10;
		const int MAX_COUNT = 500;
		CvPoint2D32f* points[2] = {0,0}, *swap_points, *point1pre=NULL;
		CvPoint2D32f *initpoints=NULL;
		char* status = 0;
		int count = 0;
		int need_to_init = 1;
		int night_mode = 0;
		int flags = 0;
		int add_remove_pt = 0;
		double delx=0,dely=0;//偏移向量
		vector<int> features4;
		vector<int>::iterator iter;
		char image_name[25];  
		IplImage* swap;
		//IplImage* bg=cvCreateImage(cvSize(GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)),IPL_DEPTH_8U,1);
		//cvNamedWindow("Adjusted",CV_WINDOW_FULLSCREEN);
		//cvShowImage("Adjusted",bg);
		//char* path="4-1.MTS";
		CvCapture* capture = cvCreateFileCapture(path);//为视频文件分配内存空间  projector2投影仪
		
		/*初始化写视频*/
		double fps = 20;/*cvGetCaptureProperty (
		capture,
		CV_CAP_PROP_FPS);*/

		CvSize size = cvSize((int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH),
		(int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT)
		);

		CvVideoWriter* writer1=cvCreateVideoWriter(
		"original.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		CvVideoWriter* writer2=cvCreateVideoWriter(
		"adjusted.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		IplImage* frame_camera=0;
			for(int framecounter=0;;framecounter++)
	{
		//if(framecounter>MAX_INT) framecounter=10;

		int i, k, c;

		frame_camera = cvQueryFrame( capture );
		//double height = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT);
		//double width = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH);
		//printf("height:%f  width:%f\n",height,width);  480*640
		double start=clock();

		if( !frame_camera ) break;

		if( !image )
		{
			// allocate all the buffers 

			image = cvCreateImage( cvGetSize(frame_camera), 8, 3 );
			featuredFrame = cvCreateImage( cvGetSize(frame_camera), 8, 3 );
			image->origin = frame_camera->origin;
			featuredFrame->origin = frame_camera->origin;

			grey = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			prev_grey = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			pyramid = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			prev_pyramid = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			points[0] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
			points[1] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
			status = (char*)cvAlloc(MAX_COUNT);
			flags = 0;

		}

		cvCopy( frame_camera, image, 0 );
		cvCvtColor( image, grey, CV_BGR2GRAY );
		cvCopy(frame_camera, featuredFrame,0);
		//cvCvtColor(featuredFrame,grey,CV_BGR2GRAY);
		
		if( night_mode )
			cvZero( image );

		if( need_to_init )
		{
			// automatic initialization 
			IplImage* eig = cvCreateImage( cvGetSize(grey), 32, 1 );
			IplImage* temp = cvCreateImage( cvGetSize(grey), 32, 1 );
			double quality = 0.05;
			double min_distance = 10;

			count = MAX_COUNT;
			cvGoodFeaturesToTrack( grey, eig, temp, points[1], &count,
				quality, min_distance, 0, 3, 0, 0.04 );
			cvFindCornerSubPix( grey, points[1], count,
				cvSize(win_size,win_size), cvSize(-1,-1),
				cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03));
			cvReleaseImage( &eig );
			cvReleaseImage( &temp );
			//initpoints=points[1];//initalize feature points
			add_remove_pt = 0;
			need_to_init=0;
		}

		else if( count > 0 )
		{
			cvCalcOpticalFlowPyrLK( prev_grey, grey, prev_pyramid, pyramid,
				points[0], points[1], count, cvSize(win_size,win_size), 3, status, 0,
				cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03), flags );
			flags |= CV_LKFLOW_PYR_A_READY;


			for( i = k = 0; i < count; i++ )
			{


				if( !status[i] ){
					points[1][i].x=0;
					points[1][i].y=0;
					//continue;
				}

				points[1][k++] = points[1][i];

				//printf("p0[x]=%f  p0[y]=%f\n",points[0]->x,points[0]->y);
				//printf("p1[x]=%f  p1[y]=%f\n\n",points[1]->x,points[1]->y);

				//cvCircle( image, cvPointFrom32f(points[1][i]), 3, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][2]), 3, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][90]), 20, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][4]), 3, CV_RGB(0,255,0), -1, 8,0);
				//translation=calcTranslation(points,1);
				//printf("trans x=%f    trans y=%f",translation[0],translation[1]);
			}
			count = k;


			if(framecounter==1){
				features4=find4Feature(frame_camera,points[1],count);
				initpoints = new CvPoint2D32f[count];
				for(int i=0; i<count; i++){
					initpoints[i]=points[1][i];//initalize feature points
				}
				// the mouse event
				/*for(int i=0;i<features4.size();i++)
				cvCircle( image, cvPointFrom32f(points[1][features4[i]]), 3, CV_RGB(0,255,0), -1, 8,0);
				cvShowImage("original",image);
				cout<<"feature size"<<features4.size()<<endl;

				char c;
				while(1){
				cvSetMouseCallback( "original", on_mouse, 0 );
				if(27==waitKey(1))
				break;
				}*/

			}
			
			if(point1pre==NULL) {
				//point1pre->x=points[1]->x;
				//point1pre->y=points[1]->y; 
				point1pre=points[1];
				//printf("innitialize prex=%f  prey=%f  p1x=%f  p1y=%f\n",point1pre[20].x,point1pre[20].y,points[1][20].x,points[1][20].y);
				//printf("innitializing points previous to points[1]\n");
			}
			//if(point1pre!=NULL) {
			//	printf("points pre not null\n");
			//}

			//for(int i=0;i<count;i++){
			//delx+=point1pre[0].x-points[1][0].x;
			//dely+=point1pre[0].y-points[1][0].y;
			//}

			//int* index=findGoodFeature(point1pre,points[1],count);
			/*
			for(int i=0;i<features4.size();i++){
			cvCircle( image, cvPointFrom32f(points[1][features4[i]]), 3, CV_RGB(0,255,0), -1, 8,0);
			//	cout<<"index   "<<index[i]<<endl;
			double dx=point1pre[features4[i]].x-points[1][features4[i]].x;
			double dy=point1pre[features4[i]].y-points[1][features4[i]].y;
			if(dx<20 && dy<20){
			delx+=dx;
			dely+=dy;
			}

			else{//cannot erase for i not for iter
			//features4.erase(iter);
			cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
			if(features4.size()==0){
			cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
			return;
			}
			}
			if(iter==features4.end())break;
			//cout<<"feature "<<i<<" delx "<< point1pre[features4[i]].x-points[1][features4[i]].x<<"  dely "<<point1pre[features4[i]].y-points[1][features4[i]].y<<endl;
			}
			*/

			/*
			for(iter=features4.begin();iter != features4.end();iter++){
			cvCircle( image, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);

			//cout<<"feature point "<<*iter<<" "<<endl;

			double dx=point1pre[*iter].x-points[1][*iter].x;
			double dy=point1pre[*iter].y-points[1][*iter].y;
			if(dx<20 && dy<20){
			delx+=dx;
			dely+=dy;
			}
			else{
			features4.erase(iter);
			cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
			if(features4.size()==0){
			cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
			return;
			}
			}
			if(iter==features4.end())break;
			//cout<<"feature "<<i<<" delx "<< point1pre[features4[i]].x-points[1][features4[i]].x<<"  dely "<<point1pre[features4[i]].y-points[1][features4[i]].y<<endl;
			}
			*/

			//initial the first frame_camera's feature points and the next frames compared to the 1st
			for(iter=features4.begin();iter != features4.end();iter++){
				cvCircle( featuredFrame, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);

				//cout<<"feature point "<<*iter<<" "<<endl;

				double dx=initpoints[*iter].x-points[1][*iter].x;
				double dy=initpoints[*iter].y-points[1][*iter].y;

				double ddx=points[0][*iter].x-points[1][*iter].x;
				double ddy=points[0][*iter].y-points[1][*iter].y;
				//cout<<"deltax="<<ddx<<"  deltay="<<ddy<<endl;
				if(ddx<20 || ddy<20){
					delx+=dx;
					dely+=dy;
				}
				else{
					features4.erase(iter);
					cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
					if(features4.size()==0){
						cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
						return;
					}
				}
				if(iter==features4.end())break;
			}

			Mat trans_mat=getTransMat(initpoints,points[1],features4);
			if(trans_mat.rows==0){
				cout<<"cannot get the transform matrix!!"<<endl;
				return;
			}
			CvMat warp_mat = trans_mat;
			cvWarpAffine( frame_camera, image, &warp_mat );  //对图像做仿射变换
			
			//swap = processShowframe(image);//处理边框  变为黑色
			//cout<<"dx="<<delx<<" dy="<<dely<<endl;
			//for(int i=0;i<40;i++){
			//delx+=point1pre[20].x-points[1][20].x;
			//dely+=point1pre[20].y-points[1][20].y;
			//}

			//cout<<"delx:"<<delx<<"dely:"<<dely<<endl;
			//delete index;
			//20px is reasonable
			//printf("current feature point20 is:%f  %f\n",points[1][20].x,points[1][20].y);
			//printf("pre  feature point20 is %f  %f\n",point1pre[20].x,point1pre[20].y);
			//delx/=count;dely/=count;
			//double finish=clock();
			//printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	


		}

		//     {
		//         points[1][count++] = cvPointTo32f(pt);

		//     }
		if(count==0) need_to_init=1;

		point1pre=points[1];//记录前一帧特征点 p1信息

		CV_SWAP( prev_grey, grey, swap_temp );
		CV_SWAP( prev_pyramid, pyramid, swap_temp );
		CV_SWAP( points[0], points[1], swap_points );
		//need_to_init = 0;

		//adjust current frame_camera to erase the tremble
		//cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
		//cvShowImage("adjusted",frame_camera);
		cvShowImage("original",featuredFrame);
		//if(framecounter%2==0){
		//Mat show=adjustFrame(image,delx,dely);
		//printf("deltax=%f   deltay=%f \n",delx,dely);	
		
		//Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
		Mat show(image,CV_8UC3);

	

		//center.x=float (Img_old->width/2.0+0.5);
	//	center.y=float (Img_old->height/2.0+0.5);   
		//double angle=calcAngle
		//delx dely =0 if use the solid 1st frame_camera
		delx=0;dely=0;
		IplImage result=show;
		//printf("adjusted frame_camera%d\n",frame_camera->height);
		//cvShowImage( "LkDemo", image );
		//imshow("adjust",show);
		double finish=clock();
		//printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	

		DrawPictureToHDC(&result,IDC_ShowFrame);

		 cvWriteFrame( writer1, frame_camera );
		 cvWriteFrame( writer2, &result );
		//}


		//ShowAdjustedFrame("Adjusted",frame_camera,delx,dely );
		c = cvWaitKey(10);
		if( (char)c == 27 )
			break;
		switch( (char) c )
		{
		case 'r':
			need_to_init = 1;
			break;
		case 'c':
			count = 0;
			break;
		case 'n':
			night_mode ^= 1;
			break;
		default:
			;
		}
		//char cc=cvWaitKey(0);
		//if (cc==27){ DestroyWindow();
		//	MessageBox(_T("列表为空"),_T("警告"),MB_ICONWARNING|MB_OK);
		//}
	}//end for
	cvReleaseVideoWriter( &writer1 );
	cvReleaseVideoWriter( &writer2 );
	cvReleaseCapture( &capture );
	cvReleaseImage(&swap);
	cvReleaseImage(&frame_camera);
	cvReleaseImage(&image);
	// TODO: 在此添加控件通知处理程序代码
	}
}

void CShakingSolutionDlg::drawBox(Point start, Point end, Mat& img){
	Scalar color = (255,255,255);
	rectangle(img, start, end, color);
}

bool isDrawing=false;
Point start_point, end_point;

void mouseEvent(int evt, int x, int y, int flags, void* param){
	if(isDrawing){
		if(evt==CV_EVENT_LBUTTONUP){
			printf("width: %d, height: %d\n",x-start_point.x,y-start_point.y);
			isDrawing = false;
			end_point.x = x;
			end_point.y = y;
			// 			Mat* image  = static_cast<Mat *>(param);
			// 			drawBox(start_point, end_point, *image);
			//  		waitKey(0);
		}
		if(evt==CV_EVENT_MOUSEMOVE){
			end_point.x = x;
			end_point.y = y;
		}
	}
	else{
		if(evt==CV_EVENT_LBUTTONDOWN){
			printf("start.x: %d, start.y: %d\n",x,y);
			isDrawing = true;
			start_point.x = x;
			start_point.y = y;
			end_point.x=x;
			end_point.y=y;
		}
	}
}

void CShakingSolutionDlg::test_grabcut(){
	Mat image;
	image= imread("tar.jpg",CV_LOAD_IMAGE_COLOR);
	namedWindow("Feed");
	cvSetMouseCallback("Feed", mouseEvent, &image);
	while (1)
	{
		Mat result= image.clone();
		if (isDrawing)
		{
			drawBox(start_point,end_point,result);
		}
		imshow("Feed",result);
		if (waitKey(10)==27)
		{
			break;
		}
	}

	// define bounding rectangle
	Rect rect(start_point.x,start_point.y,end_point.x-start_point.x,end_point.y-start_point.y);

	Mat mask; // segmentation mask (4 possible values)
	Mat bgModel,fgModel; // the models (internally used)
	// GrabCut segmentation
	grabCut(image,    // input image
		mask,   // segmentation mask
		rect,// rectangle containing foreground
		bgModel,fgModel, // models
		2,        // number of iterations
		GC_INIT_WITH_RECT); // use rectangle
	// Get the pixels marked as likely foreground, the foreground color is (255,255,255) and background color is (0,0,0), there are only two colors in the mask
	compare(mask,GC_PR_FGD,mask,CMP_EQ);
	//imshow("mask",mask);

	// Generate output image
	Mat foreground;//(image.size(),CV_8UC3,Scalar(255,255,255));
	Mat background;//(image.size(),CV_8UC3,Scalar(0,0,0));
	image.copyTo(foreground,mask); // bg pixels not copied
	image.copyTo(background,~mask);
	// draw rectangle on original image
	//imshow("foreground",foreground);
	//imshow("background",background);

	rectangle(image, rect, Scalar(255,255,255));
	imshow("original",image);
	imwrite("rose_mask.png",mask);
	imwrite("rose_rect.png",image);
	imwrite("rose_fore.png",foreground);
	imwrite("rose_back.png",background);
	waitKey(0);
}

void CShakingSolutionDlg::OnBnClickedButton3()
{
	// TODO: 在此添加控件通知处理程序代码
}

void CShakingSolutionDlg::OnBnClickedgrabcut()
{
	//test_grabcut();
	//
	// TODO: 在此添加控件通知处理程序代码
}

void CShakingSolutionDlg::OnBnClickedButton1()
{
	// TODO: 在此添加控件通知处理程序代码
}

//返回四个角特征像素点的Point
Point* findFeature(Mat frame_camera){
	Point *feature = new Point[4];
	vector<Point> potential;
	Vec3i s;
	int px=0,py=0;	//平均特征点的像素位置

	for(int i=0;i<frame_camera.rows;i++)
		for(int j=0;j<frame_camera.cols;j++){
			Vec3i s=frame_camera.at<Vec3b>(i,j);   //数据访问
			//cout<<s.val[0]<<"  "<<s.val[1]<<"  "<<s.val[2]<<endl;
			if(s[0]<100 && s[1]<100 && s[2]<100){
				potential.push_back(Point(i,j));
			}
		}

		for(int i=0;i<potential.size();i++){
			px+=potential[i].x;			
			py+=potential[i].y;
		}
		px/=potential.size();py/=potential.size();
		feature[0].x=px;feature[0].y=py;

		potential.clear();		//	清除信息

		for(int i=0;i<frame_camera.rows;i++)
			for(int j=frame_camera.cols;j>0;j--){
				Vec3i s=frame_camera.at<Vec3b>(i,j);   //数据访问
				//cout<<s.val[0]<<"  "<<s.val[1]<<"  "<<s.val[2]<<endl;
				if(s[0]<100 && s[1]<100 && s[2]<100){
					potential.push_back(Point(i,j));
				}
			}

			for(int i=0;i<potential.size();i++){
				px+=potential[i].x;			
				py+=potential[i].y;
			}
			px/=potential.size();py/=potential.size();
			feature[0].x=px;feature[0].y=py;

			potential.clear();		//	清除信息

			for(int i=frame_camera.rows;i>0;i--)
				for(int j=0;j<frame_camera.cols;j++){
					Vec3i s=frame_camera.at<Vec3b>(i,j);   //数据访问
					//cout<<s.val[0]<<"  "<<s.val[1]<<"  "<<s.val[2]<<endl;
					if(s[0]<100 && s[1]<100 && s[2]<100){
						potential.push_back(Point(i,j));
					}
				}

				for(int i=0;i<potential.size();i++){
					px+=potential[i].x;			
					py+=potential[i].y;
				}
				px/=potential.size();py/=potential.size();
				feature[0].x=px;feature[0].y=py;

				potential.clear();		//	清除信息

				for(int i=frame_camera.rows;i>0;i--)
					for(int j=frame_camera.cols;j>0;j--){
						Vec3i s=frame_camera.at<Vec3b>(i,j);   //数据访问
						//cout<<s.val[0]<<"  "<<s.val[1]<<"  "<<s.val[2]<<endl;
						if(s[0]<100 && s[1]<100 && s[2]<100){
							potential.push_back(Point(i,j));
						}
					}
					for(int i=0;i<potential.size();i++){
						px+=potential[i].x;			
						py+=potential[i].y;
					}
					px/=potential.size();py/=potential.size();
					feature[0].x=px;feature[0].y=py;

					potential.clear();		//	清除信息

					return feature;
}

Point* findAround(Mat frame_camera,Point* prePoint){
	Point* a=NULL;
	return a;
}

Mat adjustMatFrame(Mat frame_camera,double dx,double dy){
	int delx=(int)dx;int dely=(int)dy;

	//imshow("mat",mat);
	Mat temp=Mat(frame_camera.rows,frame_camera.cols,CV_8UC3);
	for(int i=0;i<temp.rows;i++)
		for(int j=0;j<temp.cols;j++)
			temp.at<Vec3b>(i,j)=frame_camera.at<Vec3b>(1,1);

	for(int i=0;i<frame_camera.rows;i++)
		for(int j=0;j<frame_camera.cols;j++){
			if( (i+delx)>0 && (i+delx)<frame_camera.rows && (j+dely)>0 && (j+dely)<frame_camera.cols){
				Vec3i s=frame_camera.at<Vec3b>(i,j);   //数据访问
				//cout<<s.val[0]<<"  "<<s.val[1]<<"  "<<s.val[2]<<endl;
				temp.at<Vec3b>(i+delx,j+dely)=s;
			}	 
		}
		return temp;
}

void addMarker_circle(IplImage** frame){
	Mat s(*frame,CV_8UC3);
	cvCircle( *frame, cvPoint(3,3), 3, CV_RGB(255,0,0), -1, 8,0);
	cvCircle( *frame, cvPoint(3,s.rows-3), 3, CV_RGB(255,0,0), -1, 8,0);
	cvCircle( *frame, cvPoint(s.cols-3,3), 3, CV_RGB(255,0,0), -1, 8,0);
	cvCircle( *frame, cvPoint(s.cols-3,s.rows-3), 3, CV_RGB(255,0,0), -1, 8,0);
}

void addMarker_rect(IplImage** frame){
	Mat s(*frame,CV_8UC3);
	int recsize=10;
	
	//debug mode
	//int b=0,g=0,r=0;
	//relaese mode
	int b=255,g=0,r=0;

	//左上
	cvRectangle(*frame,cvPoint(0,0),cvPoint(recsize-1,recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(recsize,recsize),cvPoint(2*recsize-1,2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	//左下
	/*cvRectangle(*frame,cvPoint(0,s.rows-1),cvPoint(recsize-1,s.rows-recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(recsize-1,s.rows-recsize-1),cvPoint(2*recsize-1,s.rows-2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);*/

	cvRectangle(*frame,cvPoint(0,s.rows-2*recsize-1),cvPoint(recsize-1,s.rows-recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(recsize,s.rows-recsize),cvPoint(2*recsize-1,s.rows-1),CV_RGB(b,g,r),-1, CV_AA,0);

	//右上
	/*cvRectangle(*frame,cvPoint(s.cols-1,0),cvPoint(s.cols-recsize-1,recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(s.cols-recsize-1,recsize-1),cvPoint(s.cols-2*recsize-1,2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);*/

	cvRectangle(*frame,cvPoint(s.cols-2*recsize-1,0),cvPoint(s.cols-recsize-1,recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(s.cols-recsize,recsize),cvPoint(s.cols-1,2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);

	//右下
	cvRectangle(*frame,cvPoint(s.cols-recsize-1,s.rows-recsize-1),cvPoint(s.cols-2*recsize-1,s.rows-2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(s.cols-recsize,s.rows-recsize),cvPoint(s.cols-1,s.rows-1),CV_RGB(b,g,r),-1, CV_AA,0);

	/*cvCircle( *frame, cvPoint(5,5), 5, CV_RGB(255,0,0), -1, 8,0);
	cvCircle( *frame, cvPoint(5,s.rows-5), 5, CV_RGB(255,0,255), -1, 8,0);
	cvCircle( *frame, cvPoint(s.cols-5,5), 5, CV_RGB(255,255,0), -1, 8,0);
	cvCircle( *frame, cvPoint(s.cols-5,s.rows-5), 5, CV_RGB(255,255,255), -1, 8,0);*/
}

void addMarker_cross(IplImage** frame){
	Mat s(*frame,CV_8UC3);
	int recsize=10;
	
	//debug mode
	//int b=0,g=0,r=0;
	//relaese mode
	int b=255,g=0,r=0;

	//左上
	cvRectangle(*frame,cvPoint(0,0),cvPoint(recsize-1,recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(recsize,recsize),cvPoint(2*recsize-1,2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	//左下
	/*cvRectangle(*frame,cvPoint(0,s.rows-1),cvPoint(recsize-1,s.rows-recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(recsize-1,s.rows-recsize-1),cvPoint(2*recsize-1,s.rows-2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);*/

	cvRectangle(*frame,cvPoint(0,s.rows-2*recsize-1),cvPoint(recsize-1,s.rows-recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(recsize,s.rows-recsize),cvPoint(2*recsize-1,s.rows-1),CV_RGB(b,g,r),-1, CV_AA,0);

	//右上
	/*cvRectangle(*frame,cvPoint(s.cols-1,0),cvPoint(s.cols-recsize-1,recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(s.cols-recsize-1,recsize-1),cvPoint(s.cols-2*recsize-1,2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);*/

	cvRectangle(*frame,cvPoint(s.cols-2*recsize-1,0),cvPoint(s.cols-recsize-1,recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(s.cols-recsize,recsize),cvPoint(s.cols-1,2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);

	//右下
	cvRectangle(*frame,cvPoint(s.cols-recsize-1,s.rows-recsize-1),cvPoint(s.cols-2*recsize-1,s.rows-2*recsize-1),CV_RGB(b,g,r),-1, CV_AA,0);
	cvRectangle(*frame,cvPoint(s.cols-recsize,s.rows-recsize),cvPoint(s.cols-1,s.rows-1),CV_RGB(b,g,r),-1, CV_AA,0);

	/*cvCircle( *frame, cvPoint(5,5), 5, CV_RGB(255,0,0), -1, 8,0);
	cvCircle( *frame, cvPoint(5,s.rows-5), 5, CV_RGB(255,0,255), -1, 8,0);
	cvCircle( *frame, cvPoint(s.cols-5,5), 5, CV_RGB(255,255,0), -1, 8,0);
	cvCircle( *frame, cvPoint(s.cols-5,s.rows-5), 5, CV_RGB(255,255,255), -1, 8,0);*/
}

Point avg_Marker(vector<Point> marker){
	int sumx=0,sumy=0,x,y;
	Point p;

	if(marker.size() != 0){
		for(int i=0;i<marker.size();i++){
			sumx+=marker[i].x;
			sumy+=marker[i].y;
		}
		x=sumx/marker.size();
		y=sumy/marker.size();
		p.x=x;p.y=y;	
	}
	else{
		cout<<"there is no marker point....."<<endl;
		//cv::waitKey();
		p.x=0;p.y=0;
	}
	return p;
}

vector<Point> findMarkers_circle(IplImage* frame_camera){

	vector<Point>markers;//the 4 markers point
	vector<Point>m1,m2,m3,m4;//存储左上，右上，左下，右下四部分的符合特征的marker点
	vector<int> features;
	Mat mat(frame_camera);
//	for(int i=0;i<mat.rows;i++){
//		for(int j=0;j<mat.cols;j++)
////			if(px >= 0&& py >= 0)
//			{
//				Vec3b s=mat.at<Vec3b>(px,py);
//					if(( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) || 
//					(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols) || 
//					(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4) || 
//					(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols) )
//					)													
//
//				{
//					features.push_back(i);
//					//if(features.size()==4) return features;
//				}
//			}//end if
//	}//end for
	for(int px=0;px<mat.rows;px++)
		for(int py=0;py<mat.cols;py++){
			Vec3i s=mat.at<Vec3b>(px,py);
			//左上m1特征点存储
			/*if( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) && (s[0]<100 && s[1]<100 && s[2]>100 )					 
			   )*/

			if( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2) && (s[0]<100 && s[1]<100 && s[2]>100 )					 
			   )

			{
				m1.push_back(Point(py,px));
			}

			//右上m2特征点存储
			/*if(	(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols) && (s[0]<100 && s[1]<100 && s[2]>100 )		
			  )	*/

			if(	(px>0 && px<mat.rows/2 && py>mat.cols/2 && py<mat.cols) && (s[0]<100 && s[1]<100 && s[2]>100 )		
			)	

			{
				m2.push_back(Point(py,px));
			}

			//左下m3特征点存储
			/*if(	(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4) && (s[0]<100 && s[1]<100 && s[2]>100)		
			   )*/

			if(	(px>mat.rows/2 && px<mat.rows && py>0 && py<mat.cols/2) && (s[0]<100 && s[1]<100 && s[2]>100)		
			   )

			{
				m3.push_back(Point(py,px));
			}

			//右下m4特征点存储
			/*if(	(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols) && (s[0]<100 && s[1]<100 && s[2]>100)		
			   )*/

			if(	(px>mat.rows/2 && px<mat.rows && py>mat.cols/2 && py<mat.cols) && (s[0]<100 && s[1]<100 && s[2]>100)		
				)

			{
				m4.push_back(Point(py,px));
			}

			/*if(s[0]>100 && s[1]<100 && s[2]<100)
				m4.push_back(Point(py,px));*/
		}//end for
		cout<<"m1.size"<<m1.size()<<endl;
			/*calculate the average 4 markers point */
		/*if(m1.size()==0 || m2.size()==0 || m3.size()==0 || m4.size()==0){
			cout<<"size ==0 "<<endl;
			cv::waitKey();
		}*/
		
			Point marker1=avg_Marker(m1);
			Point marker2=avg_Marker(m2);
			Point marker3=avg_Marker(m3);
			Point marker4=avg_Marker(m4);

			markers.push_back(marker1);
			markers.push_back(marker2);
			markers.push_back(marker3);
			markers.push_back(marker4);

		return markers;
}

vector<Point> findMarkers_rect(IplImage* frame_camera){
	vector<Point>markers;//the 4 markers point
	vector<Point>m1,m2,m3,m4;//存储左上，右上，左下，右下四部分的符合特征的marker点
	vector<int> features;
	Mat mat(frame_camera);

	Mat mat_binary(mat);

	/*threshholding the captured image*/
	int threshold_binaryzation=100;

	for(int px=0;px<mat.rows;px++)
		for(int py=0;py<mat.cols;py++){
			Vec3b s=mat.at<Vec3b>(px,py);
						//左上m1特征点存储
			/*if( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) ||
				(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols)||
				(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4)||
				(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols)
				)		*/
			if( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2) ||
				(px>0 && px<mat.rows/2 && py>mat.cols/2 && py<mat.cols)||
				(px>mat.rows/2 && px<mat.rows && py>0 && py<mat.cols/2)||
				(px>mat.rows/2 && px<mat.rows && py>mat.cols/2 && py<mat.cols)
				)		
			/*if( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)					 
			   )*/
			{
				if(( s[0]<threshold_binaryzation && s[1]<threshold_binaryzation && s[2]<threshold_binaryzation)	){
					s[0]=0;s[1]=0;s[2]=0;
					mat_binary.at<Vec3b>(px,py)=s;
				}
					
				else{
					s[0]=255;s[1]=255;s[2]=255;
					mat_binary.at<Vec3b>(px,py)=s;
				}
			}//end if		
		}//end for


	//cv::Mat mat1(mat.size(),mat.type());
	//cv::cvtColor(mat,mat1,CV_BGR2Lab);
	//cv::imshow("hls",mat1);
	//cv::waitKey();

	int threshold_pix=250;//像素差

	for(int px=1;px<mat_binary.rows-1;px++)
		for(int py=1;py<mat_binary.cols-1;py++){
			Vec3i s=mat_binary.at<Vec3b>(px,py);
			Vec3i s1=mat_binary.at<Vec3b>(px-1,py);
			Vec3i s2=mat_binary.at<Vec3b>(px+1,py);

			Vec3i s3=mat_binary.at<Vec3b>(px,py-1);
			Vec3i s4=mat_binary.at<Vec3b>(px,py+1);

		/*	if( abs(s1[1]-s2[1])>30 && abs(s3[1]-s4[1])>30)
				markers.push_back(Point(py,px));*/

			//左上m1特征点存储
			/*if( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)					 
			   )*/		
			if( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)					 
			   )
			{
				m1.push_back(Point(py,px));
			}

			//右上m2特征点存储
			/*if(	(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)		
			  )*/	
			if(	(px>0 && px<mat.rows/2 && py>mat.cols/2 && py<mat.cols) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)		
			)	
			{
				m2.push_back(Point(py,px));
			}

			//左下m3特征点存储
			/*if(	(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1])>threshold_pix)		
			   )*/
			if(	(px>mat.rows/2 && px<mat.rows && py>0 && py<mat.cols/2) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1])>threshold_pix)		
			   )
			{
				m3.push_back(Point(py,px));
			}

			//右下m4特征点存储
			/*if(	(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)		
			   )*/
			if(	(px>mat.rows/2 && px<mat.rows && py>mat.cols/2 && py<mat.cols) && (abs(s1[1]-s2[1]) > threshold_pix && abs(s3[1]-s4[1]) > threshold_pix)		
			   )
			{
				m4.push_back(Point(py,px));
			}

		}//end for

		cout<<"m1.size"<<m1.size()<<endl;

			/*calculate the average 4 markers point */
		/*if(m1.size()==0 || m2.size()==0 || m3.size()==0 || m4.size()==0){
			cout<<"size ==0 "<<endl;
			cv::waitKey();
		}*/
		
			Point marker1=avg_Marker(m1);
			Point marker2=avg_Marker(m2);
			Point marker3=avg_Marker(m3);
			Point marker4=avg_Marker(m4);

			markers.push_back(marker1);
			markers.push_back(marker2);
			markers.push_back(marker3);
			markers.push_back(marker4);

		return markers;
}

vector<Point> findMarkers_cross(IplImage* frame_camera){
	vector<Point>markers;//the 4 markers point
	vector<Point>m1,m2,m3,m4;//存储左上，右上，左下，右下四部分的符合特征的marker点
	vector<int> features;
	Mat mat(frame_camera);

	int threshold_r=100;//r像素

	for(int px=1;px<mat.rows-1;px++)
		for(int py=1;py<mat.cols-1;py++){
			//s[0]=b;s[1]=g;s[2]=r
			Vec3i s=mat.at<Vec3b>(px,py);
			/*Vec3i s1=mat.at<Vec3b>(px-1,py);
			Vec3i s2=mat.at<Vec3b>(px+1,py);

			Vec3i s3=mat.at<Vec3b>(px,py-1);
			Vec3i s4=mat.at<Vec3b>(px,py+1);*/

		/*	if( abs(s1[1]-s2[1])>30 && abs(s3[1]-s4[1])>30)
				markers.push_back(Point(py,px));*/
			int b=(int)s[0],g=(int)s[1],r=(int)s[2];
			//red point
		/*	if( s[2] > threshold_r && s[2] > s[0] && s[2] > s[1]){*/
			if(  (b> r) && (b>g) ){
				//左上m1特征点存储
				/*if( (px>0 && px<mat.rows/4 && py>0 && py<mat.cols/4)				 
				   )*/	
				if( (px>0 && px<mat.rows/2 && py>0 && py<mat.cols/2)				 
				   )

				{
					m1.push_back(Point(py,px));
				}

				//右上m2特征点存储
				/*if(	(px>0 && px<mat.rows/4 && py>3*mat.cols/4 && py<mat.cols)
				  )*/	
				if(	(px>0 && px<mat.rows/2 && py>mat.cols/2 && py<mat.cols)
				  )	

				{
					m2.push_back(Point(py,px));
				}

				//左下m3特征点存储
				/*if(	(px>3*mat.rows/4 && px<mat.rows && py>0 && py<mat.cols/4)
				   )*/
				if(	(px>mat.rows/2 && px<mat.rows && py>0 && py<mat.cols/2)
				   )

				{
					m3.push_back(Point(py,px));
				}

				//右下m4特征点存储
				/*if(	(px>3*mat.rows/4 && px<mat.rows && py>3*mat.cols/4 && py<mat.cols)	
				   )*/
				if(	(px>mat.rows/2 && px<mat.rows && py>mat.cols/2 && py<mat.cols)	
				   )

				{
					m4.push_back(Point(py,px));
				}	
			}//end if			
		}//end for
		cout<<"m1.size"<<m1.size()<<endl;
		cout<<"m2.size"<<m2.size()<<endl;
		cout<<"m3.size"<<m3.size()<<endl;
		cout<<"m4.size"<<m4.size()<<endl;
		
			/*calculate the average 4 markers point */
		/*if(m1.size()==0 || m2.size()==0 || m3.size()==0 || m4.size()==0){
			cout<<"size ==0 "<<endl;
			cv::waitKey();
		}*/
		
			Point marker1=avg_Marker(m1);
			Point marker2=avg_Marker(m2);
			Point marker3=avg_Marker(m3);
			Point marker4=avg_Marker(m4);

			markers.push_back(marker1);
			markers.push_back(marker2);
			markers.push_back(marker3);
			markers.push_back(marker4);
			
			/*code to return  all markers */
			int count=0;
			while(count<m1.size() || count<m2.size() || count<m3.size() || count<m4.size()){
				Point m;
				if(count<m1.size())
					markers.push_back(m1[count]);
				if(count<m2.size())
					markers.push_back(m2[count]);
				if(count<m3.size())
					markers.push_back(m3[count]);
				if(count<m4.size())
					markers.push_back(m4[count]);
				count++;
			}
			/*end*/

		
		return markers;
}

void markCrossPoint(IplImage* frame_video,vector<Point>capturedMarkers){
	Mat mat(frame_video);
	for(int i=0;i<capturedMarkers.size();i++){
		/*marker the points*/
		mat.at<Vec3b>(capturedMarkers[i].y,capturedMarkers[i].x)=Vec3b(0,0,0);
	}
	
	/*get a 2 value image*/
	for(int i=0;i<mat.rows;i++)
		for(int j=0;j<mat.cols;j++){
			if(mat.at<Vec3b>(i,j)!=Vec3b(0,0,0))
				mat.at<Vec3b>(i,j)=Vec3b(255,255,255);
		}

}

Mat getTranMat(vector<Point>init,vector<Point>captured){
	//vector<Point2f> vec1,vec2;
	Mat transform;
	transform=estimateRigidTransform(captured,init,false);
	return transform;
}

Mat get_tsr_matrix( const vector<Point> &points1, const vector<Point> &points2 )
{
	// 转换成解方程 A * X = B
	// X1 * S * cos - Y1 * sin + dx = X2;
	// X1 * sin + Y1 * S * cos + dy = Y2;

	if(points1.size() < 2)
	{
		cout << "get_tsr_matrix():not enough points." << endl;
		return Mat();
	}

	int rows = 2 * points1.size();
	Mat A = Mat::zeros( rows, 4, CV_64F );
	Mat X = Mat::zeros( 4, 1, CV_64F );
	Mat B = Mat::zeros( rows, 1, CV_64F );

	for( unsigned int i=0; i<points1.size(); i++)
	{
		A.at<double>(2*i, 0) = points1[i].x;
		A.at<double>(2*i, 1) = -points1[i].y;
		A.at<double>(2*i, 2) = 1;
		A.at<double>(2*i, 3) = 0;

		A.at<double>(2*i+1, 0) = points1[i].y;
		A.at<double>(2*i+1, 1) = points1[i].x;
		A.at<double>(2*i+1, 2) = 0;
		A.at<double>(2*i+1, 3) = 1;

		B.at<double>(2*i, 0) = points2[i].x;
		B.at<double>(2*i+1, 0) = points2[i].y;
	}

	solve( A, B, X, DECOMP_SVD ); 

	double s_cos = X.at<double>(0, 0);
	double sin = X.at<double>(1, 0);
	double dx = X.at<double>(2, 0);
	double dy = X.at<double>(3, 0);
	Mat tsr = (Mat_<double>(2, 3) << s_cos, -sin, dx, sin, s_cos, dy);

	return tsr;
}

/*feature_based_deshake();	以前动态寻找特征点 进行调整投影仪方法*/	
void feature_based_deshake(){
	
{   	
	//// TODO: 在此添加控件通知处理程序代码
	////cvNamedWindow("adjusted");
	//// TODO: Add your command handler code here
	//CString FilePathName;
	//char* path;
	//CFileDialog dlg(TRUE, //TRUE为OPEN对话框，FALSE为SAVE AS对话框
	//	NULL, 
	//	NULL,
	//	OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
	//	(LPCTSTR)_TEXT("MTS Files (*.MTS)|*.MTS|All Files (*.*)|*.*||"),
	//	NULL);

	//if(dlg.DoModal()==IDOK)
	//{
	//	FilePathName=dlg.GetPathName(); //文件名保存在了FilePathName里
	//	path=(LPSTR)(LPCTSTR)FilePathName;
	//	//path=FilePathName.GetBuffer(0);
	//	//CString strMsg=_T("当前文件打开路径为：\n")+FilePathName;//测试用的 可以删掉
	//	//MessageBox(strMsg);//测试用的 可以删掉
	//	//printf("file path%s",path);
	//	VideoCapture inputVideo(path);
	//	if(!inputVideo.isOpened()){
	//		cout<<"Open error"<<endl;
	//		return;
	//	}
	//	Size size=Size(inputVideo.get((int)CV_CAP_PROP_FRAME_WIDTH),
	//		inputVideo.get((int)CV_CAP_PROP_FRAME_HEIGHT));
	//	double fps=inputVideo.get(CV_CAP_PROP_FPS);
	IplImage* testframe=cvCreateImage(cvSize(300,400), 32, 1 );;
	//	Mat frame_camera;
	//	vector<Mat> spl;	//存储RGB分量
	//	int count=0;	// frame_camera count
	//	Point* featurePoint;
	//	Point* prePoint=NULL;		
	//	double delx=0,dely=0;	//偏移量

	//	while(true){
	//		inputVideo>>frame_camera;	//读取一帧
	//		count++;
	//		if(frame_camera.empty())break;

	//		imshow("name",frame_camera);	



	//		if(prePoint==NULL) {
	//			featurePoint=findFeature(frame_camera);	//首帧找特征点
	//			prePoint=featurePoint;
	//			//printf("innitialize prex=%f  prey=%f  p1x=%f  p1y=%f\n",point1pre[20].x,point1pre[20].y,points[1][20].x,points[1][20].y);
	//			//printf("innitializing points previous to points[1]\n");
	//		}
	//		featurePoint=findAround(frame_camera,prePoint);
	//		for(int i=0;i<4;i++){
	//			delx+=prePoint[i].x-featurePoint[i].x;
	//			dely+=prePoint[i].y-featurePoint[i].y;
	//		}
	//		delx/=4;
	//		dely/=4;

	//		prePoint=featurePoint;//记录前一帧特征点 p1信息

	//		Mat show=adjustMatFrame(frame_camera,delx,dely);
	//		IplImage result=show;
	//		//printf("adjusted frame_camera%d\n",frame_camera->height);
	//		//cvShowImage( "LkDemo", image );
	//		//imshow("adjust",show);
	//		DrawPictureToHDC(&result,IDC_ShowFrame);

	//		int c=waitKey(27);
	//		if (c==27)
	//			break;

	//	}//end while
	//}//end button click

	cvNamedWindow("original",0);
	cvNamedWindow("projector",0);
	// TODO: Add your command handler code here
	CString FilePathName;
	char* path;
	CFileDialog dlg(TRUE, //TRUE为OPEN对话框，FALSE为SAVE AS对话框
		NULL, 
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		(LPCTSTR)_TEXT("MTS Files (*.MTS)|*.avi|All Files (*.*)|*.*||"),
		NULL);

	if(dlg.DoModal()==IDOK)
	{
		FilePathName=dlg.GetPathName(); //文件名保存在了FilePathName里
		path=(LPSTR)(LPCTSTR)FilePathName;
		//path=FilePathName.GetBuffer(0);
		//CString strMsg=_T("当前文件打开路径为：\n")+FilePathName;//测试用的 可以删掉
		//MessageBox(strMsg);//测试用的 可以删掉
		//printf("file path%s",path);

		IplImage *image = 0, *featuredFrame=0,*grey = 0, *prev_grey = 0, *pyramid = 0, *prev_pyramid = 0, *swap_temp;
		int win_size = 10;
		const int MAX_COUNT = 500;
		CvPoint2D32f* points[2] = {0,0}, *swap_points, *point1pre=NULL;
		CvPoint2D32f *initpoints=NULL;
		char* status = 0;
		int count = 0;
		int need_to_init = 1;
		int night_mode = 0;
		int flags = 0;
		int add_remove_pt = 0;
		double delx=0,dely=0;//偏移向量
		vector<int> features4,reduced_features;
		vector<int>::iterator iter;
		char image_name[25];  
		IplImage* swap;
		//IplImage* bg=cvCreateImage(cvSize(GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)),IPL_DEPTH_8U,1);
		//cvNamedWindow("Adjusted",CV_WINDOW_FULLSCREEN);
		//cvShowImage("Adjusted",bg);
		//char* path="4-1.MTS";
		CvCapture* capture = cvCreateFileCapture(path);//为视频文件分配内存空间  projector2投影仪
		CvCapture* capture2 = cvCaptureFromCAM(0);
		if( !capture2 )
		{
			fprintf(stderr,"Could not initialize capturing...\n");
			return;
		}
		/*初始化写视频*/
		double fps = 20;/*cvGetCaptureProperty (
		capture,
		CV_CAP_PROP_FPS);*/

		CvSize size = cvSize((int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH),
		(int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT)
		);

		CvVideoWriter* writer1=cvCreateVideoWriter(
		"original.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		CvVideoWriter* writer2=cvCreateVideoWriter(
		"adjusted.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		IplImage* frame_video=0,*frame_camera=0;
		for(int framecounter=0;;)
	{
		//if(framecounter>MAX_INT) framecounter=10;

		int i, k, c;

		frame_video = cvQueryFrame( capture );
		frame_camera=cvQueryFrame(capture2);
		//frame_camera=frame_camera;
		//double height = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT);
		//double width = cvGetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH);
		//printf("height:%f  width:%f\n",height,width);  480*640
	//	feature_based_deshake(frame_video,frame_camera,framecounter);
		
		double start=clock();

		if( !frame_camera ) break;

		if( !image )
		{
			// allocate all the buffers 

			image = cvCreateImage( cvGetSize(frame_camera), 8, 3 );
			image->origin = frame_camera->origin;
			featuredFrame = cvCreateImage( cvGetSize(frame_camera), 8, 3 );
			featuredFrame->origin = frame_camera->origin;

			grey = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			prev_grey = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			pyramid = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			prev_pyramid = cvCreateImage( cvGetSize(frame_camera), 8, 1 );
			points[0] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
			points[1] = (CvPoint2D32f*)cvAlloc(MAX_COUNT*sizeof(points[0][0]));
			status = (char*)cvAlloc(MAX_COUNT);
			flags = 0;

		}

		cvCopy( frame_camera, image, 0 );
		cvCvtColor( image, grey, CV_BGR2GRAY );
		cvCopy( frame_camera, featuredFrame, 0 );

		if( night_mode )
			cvZero( image );

		if( need_to_init )
		{
			// automatic initialization 
			IplImage* eig = cvCreateImage( cvGetSize(grey), 32, 1 );
			IplImage* temp = cvCreateImage( cvGetSize(grey), 32, 1 );
			double quality = 0.05;
			double min_distance = 10;

			count = MAX_COUNT;
			cvGoodFeaturesToTrack( grey, eig, temp, points[1], &count,
				quality, min_distance, 0, 3, 0, 0.04 );
			cvFindCornerSubPix( grey, points[1], count,
				cvSize(win_size,win_size), cvSize(-1,-1),
				cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03));
			cvReleaseImage( &eig );
			cvReleaseImage( &temp );
			//initpoints=points[1];//initalize feature points
			add_remove_pt = 0;
			need_to_init=0;
		}
		
		else if( count > 0 )
		{
			cvCalcOpticalFlowPyrLK( prev_grey, grey, prev_pyramid, pyramid,
				points[0], points[1], count, cvSize(win_size,win_size), 3, status, 0,
				cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20,0.03), flags );
			flags |= CV_LKFLOW_PYR_A_READY;


			for( i = k = 0; i < count; i++ )
			{


				if( !status[i] ){
					//points[1][i].x=0;
					//points[1][i].y=0;
					//continue;
				}

				points[1][k++] = points[1][i];

				//printf("p0[x]=%f  p0[y]=%f\n",points[0]->x,points[0]->y);
				//printf("p1[x]=%f  p1[y]=%f\n\n",points[1]->x,points[1]->y);

				//cvCircle( image, cvPointFrom32f(points[1][i]), 3, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][2]), 3, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][90]), 20, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( image, cvPointFrom32f(points[1][4]), 3, CV_RGB(0,255,0), -1, 8,0);
				//translation=calcTranslation(points,1);
				//printf("trans x=%f    trans y=%f",translation[0],translation[1]);
			}
			count = k;


			if(framecounter==1){
				features4=find4Feature(frame_camera,points[1],count);
				initpoints = new CvPoint2D32f[count];
				for(int i=0; i<count; i++){
					initpoints[i]=points[1][i];//initalize feature points
				}
				// the mouse event
				/*for(int i=0;i<features4.size();i++)
				cvCircle( image, cvPointFrom32f(points[1][features4[i]]), 3, CV_RGB(0,255,0), -1, 8,0);
				cvShowImage("original",image);
				cout<<"feature size"<<features4.size()<<endl;

				char c;
				while(1){
				cvSetMouseCallback( "original", on_mouse, 0 );
				if(27==waitKey(1))
				break;
				}*/

			}

			if(point1pre==NULL) {
				//point1pre->x=points[1]->x;
				//point1pre->y=points[1]->y; 
				point1pre=points[1];
				//printf("innitialize prex=%f  prey=%f  p1x=%f  p1y=%f\n",point1pre[20].x,point1pre[20].y,points[1][20].x,points[1][20].y);
				//printf("innitializing points previous to points[1]\n");
			}
			//if(point1pre!=NULL) {
			//	printf("points pre not null\n");
			//}

			//for(int i=0;i<count;i++){
			//delx+=point1pre[0].x-points[1][0].x;
			//dely+=point1pre[0].y-points[1][0].y;
			//}

			//int* index=findGoodFeature(point1pre,points[1],count);
			/*
			for(int i=0;i<features4.size();i++){
			cvCircle( image, cvPointFrom32f(points[1][features4[i]]), 3, CV_RGB(0,255,0), -1, 8,0);
			//	cout<<"index   "<<index[i]<<endl;
			double dx=point1pre[features4[i]].x-points[1][features4[i]].x;
			double dy=point1pre[features4[i]].y-points[1][features4[i]].y;
			if(dx<20 && dy<20){
			delx+=dx;
			dely+=dy;
			}

			else{//cannot erase for i not for iter
			//features4.erase(iter);
			cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
			if(features4.size()==0){
			cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
			return;
			}
			}
			if(iter==features4.end())break;
			//cout<<"feature "<<i<<" delx "<< point1pre[features4[i]].x-points[1][features4[i]].x<<"  dely "<<point1pre[features4[i]].y-points[1][features4[i]].y<<endl;
			}
			*/

			/*
			for(iter=features4.begin();iter != features4.end();iter++){
			cvCircle( image, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);

			//cout<<"feature point "<<*iter<<" "<<endl;

			double dx=point1pre[*iter].x-points[1][*iter].x;
			double dy=point1pre[*iter].y-points[1][*iter].y;
			if(dx<20 && dy<20){
			delx+=dx;
			dely+=dy;
			}
			else{
			features4.erase(iter);
			cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
			if(features4.size()==0){
			cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
			return;
			}
			}
			if(iter==features4.end())break;
			//cout<<"feature "<<i<<" delx "<< point1pre[features4[i]].x-points[1][features4[i]].x<<"  dely "<<point1pre[features4[i]].y-points[1][features4[i]].y<<endl;
			}
			*/

			//initial the first frame_camera's feature points and the next frames compared to the 1st
			int j=0,k =0;
			for(iter=features4.begin(),i=0,j=0,k = 0;iter != features4.end();iter++){
				
				cvCircle( featuredFrame, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);
				
				//cout<<"feature point "<<*iter<<" "<<endl;

				double dx=initpoints[*iter].x-points[1][*iter].x;
				double dy=initpoints[*iter].y-points[1][*iter].y;

				double ddx=points[0][*iter].x-points[1][*iter].x;
				double ddy=points[0][*iter].y-points[1][*iter].y;
				
				//cout<<"deltax="<<ddx<<"  deltay="<<ddy<<endl;
				if(ddx<20 || ddy<20){
					delx+=dx;
					dely+=dy;
					reduced_features.push_back(*iter);
				}
				//else{
				//	printf("i = %d\n",i);
				//	i++;
				//	features4.erase(iter);
				//	//if(iter == features4.end())
				//	
				//	//iter = features4.begin();
				//	printf("j = %d\n",j);
				//	j++;
				//	//iter++;
				//	//iter--;
				//	printf("k = %d\n",k);
				//	k++;
				//	cout<<"erase a bad feature...current features:"<<features4.size()<<endl;
				//	if(features4.size()==0){
				//		cout<<"cannot find valid features ! \nPlease restart program...."<<endl;
				//		return;
				//	}
				//}
				
				/*if(iter==features4.end())
					break;*/
			}

			static int s=0, s1 = 0, s2 = 0;
			//printf("s = %d\n",s);
			Mat trans_mat=getTransMat(initpoints,points[1],reduced_features);
			if(trans_mat.rows==0){
				cout<<"cannot get the transform matrix!!"<<endl<<endl;
				need_to_init=1;
				framecounter=0;
		/*		for(int i=0;i<reduced_features.size();i++){
					cout<<"initial feture points x="<<initpoints[reduced_features[i]].x<<"   y="<<initpoints[reduced_features[i]].y<<endl;
					cout<<"current feture points x="<<points[1][reduced_features[i]].x<<"   y="<<points[1][reduced_features[i]].y<<endl;
				}
				return;*/
				continue;
			}
			CvMat warp_mat = trans_mat;
			//printf("s1 = %d\n",s1);
			//printf("trans_mat's size=%d\n",trans_mat.rows);
			cvWarpAffine( frame_video, image, &warp_mat );  //对图像做仿射变换
			//printf("s2 = %d\n",s2);
			swap = processShowframe(image);//处理边框  变为黑色
			
			reduced_features.clear();
			//cout<<"dx="<<delx<<" dy="<<dely<<endl;
			//for(int i=0;i<40;i++){
			//delx+=point1pre[20].x-points[1][20].x;
			//dely+=point1pre[20].y-points[1][20].y;
			//}

			//cout<<"delx:"<<delx<<"dely:"<<dely<<endl;
			//delete index;
			//20px is reasonable
			//printf("current feature point20 is:%f  %f\n",points[1][20].x,points[1][20].y);
			//printf("pre  feature point20 is %f  %f\n",point1pre[20].x,point1pre[20].y);
			//delx/=count;dely/=count;
			//double finish=clock();
			//printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	


		}

		//     {
		//         points[1][count++] = cvPointTo32f(pt);

		//     }
		if(count==0) need_to_init=1;

		point1pre=points[1];//记录前一帧特征点 p1信息

		CV_SWAP( prev_grey, grey, swap_temp );
		CV_SWAP( prev_pyramid, pyramid, swap_temp );
		CV_SWAP( points[0], points[1], swap_points );
		//need_to_init = 0;

		//adjust current frame_camera to erase the tremble
		//cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
		//cvShowImage("adjusted",frame_camera);
		cvShowImage("original",featuredFrame);
		//if(framecounter%2==0){
		//Mat show=adjustFrame(image,delx,dely);
		//printf("deltax=%f   deltay=%f \n",delx,dely);	
		addMarker_circle(&image);
		//Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
		Mat show(image,CV_8UC3);
		
	

		//center.x=float (Img_old->width/2.0+0.5);
		//center.y=float (Img_old->height/2.0+0.5);   
		//double angle=calcAngle
		//delx dely =0 if use the solid 1st frame_camera
		delx=0;dely=0;
		IplImage result=show;
		//printf("adjusted frame_camera%d\n",frame_camera->height);
		//cvShowImage( "LkDemo", image );
		//imshow("adjust",show);
		double finish=clock();
		//printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	

		//DrawPictureToHDC(frame_camera,IDC_ShowFrame);
		cvShowImage("projector",&result);
		//cvWriteFrame( writer1, testframe);
		 
		cvWriteFrame( writer1, frame_camera );
		 cvWriteFrame( writer2, &result );
		//}


		//ShowAdjustedFrame("Adjusted",frame_camera,delx,dely );
		c = cvWaitKey(10);
		if( (char)c == 27 )
			break;
		switch( (char) c )
		{
		case 'r':
			need_to_init = 1;
			break;
		case 'c':
			count = 0;
			break;
		case 'n':
			night_mode ^= 1;
			break;
		default:
			;
		}
		framecounter++;
		//char cc=cvWaitKey(0);
		//if (cc==27){ DestroyWindow();
		//	MessageBox(_T("列表为空"),_T("警告"),MB_ICONWARNING|MB_OK);
		//}
	}//end for
	cvReleaseVideoWriter( &writer1 );
	cvReleaseVideoWriter( &writer2 );
	cvReleaseCapture( &capture );
	cvReleaseImage(&swap);
	cvReleaseImage(&frame_camera);
	cvReleaseImage(&image);
	// TODO: 在此添加控件通知处理程序代码
	}
}//end function
}

void marker_based_deshake_circle(){

	// TODO: Add your command handler code here
	CString FilePathName;
	char* path;
	CFileDialog dlg(TRUE, //TRUE为OPEN对话框，FALSE为SAVE AS对话框
		NULL, 
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		(LPCTSTR)_TEXT("MTS Files (*.MTS)|*.avi|All Files (*.*)|*.*||"),
		NULL);

	if(dlg.DoModal()==IDOK)
	{
		FilePathName=dlg.GetPathName(); //文件名保存在了FilePathName里
		//path=(LPSTR)(LPCTSTR)FilePathName;
		std:string _path = FilePathName.GetBuffer(0);;
		//path=FilePathName.GetBuffer(0);
		//CString strMsg=_T("当前文件打开路径为：\n")+FilePathName;//测试用的 可以删掉
		//MessageBox(strMsg);//测试用的 可以删掉
		//printf("file path%s",path);
		cvNamedWindow("original_marker",0);
		cvNamedWindow("projector_marker",0);
		cvNamedWindow("projector_adjust",0);
		IplImage  *featuredFrame=0,*image=0,*swap=0;
		int win_size = 10;
		
		double delx=0,dely=0;//偏移向量
		vector<int> features4,reduced_features;
		vector<int>::iterator iter;
		vector<Point>initMarkers,capturedMarkers;
		
		char image_name[25];  
		//IplImage* bg=cvCreateImage(cvSize(GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)),IPL_DEPTH_8U,1);
		//cvNamedWindow("Adjusted",CV_WINDOW_FULLSCREEN);
		//cvShowImage("Adjusted",bg);
		//char* path="4-1.MTS";
		CvCapture* capture = cvCreateFileCapture(_path.c_str());//为视频文件分配内存空间  projector2投影仪
		
		CvCapture* capture2 = cvCaptureFromCAM(0);
		int init=0;
		char cc;
		if( !capture2 )
		{
			fprintf(stderr,"Could not initialize capturing...\n");
			return;
		}
		/*初始化写视频*/
		double fps = 20;/*cvGetCaptureProperty (
		capture,
		CV_CAP_PROP_FPS);*/

		CvSize size = cvSize((int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH),
		(int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT)
		);

		CvVideoWriter* writer1=cvCreateVideoWriter(
		"original.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		CvVideoWriter* writer2=cvCreateVideoWriter(
		"adjusted.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		IplImage* frame_video=0,*frame_camera=0;
		for(int framecounter=0;;framecounter++)
		{
			frame_video = cvQueryFrame( capture );
			
			//addMarker_circle(&frame_video);
			cvShowImage("projector_marker",frame_video);
		
			if(!init){
				cout<<"please adjusted the image to be projected.....  ";
				cout<<"press 'a'  to start"<<endl;
			    cc=waitKey(0);
				if(cc=='a'){
					cout<<"start capture..."<<endl;
					init=1;
				}
			}

			frame_camera= cvQueryFrame(capture2);
			cvShowImage("original_marker",frame_video);

			/*1st camera frame 
			  find the initial markers; initilize the captured markers */
			if(init==1 && framecounter==0){
				cout<<"finding the 1st markers from the frame_camera"<<endl;				
				initMarkers=findMarkers_circle(frame_video);
				capturedMarkers=initMarkers;
			}
			else{
				capturedMarkers=findMarkers_circle(frame_video);
			}

			//显示4 marker
			if(capturedMarkers[1].x==0 && capturedMarkers[1].y==0)
				return;

			for(int i=0;i<capturedMarkers.size();i++){
				cout<<capturedMarkers[i].x<<" " <<capturedMarkers[i].y<<endl;
				cvCircle( frame_video, CvPoint(capturedMarkers[i]), 1, CV_RGB(0,255,0), -1, 8,0);
			}

			cvShowImage("projector_marker",frame_video);
			cvWriteFrame( writer1, frame_video );

			if(initMarkers.size()==4 && capturedMarkers.size()==4){
				Mat tranMat=get_tsr_matrix(capturedMarkers,initMarkers);
				CvMat warp_mat = tranMat;
				cvWarpAffine( frame_video, frame_video, &warp_mat );  //对图像做仿射变换
			}
			else{
				cout<<"markers not found "<<endl;
				continue;
			}
			//	
			//if(tranMat.rows==0){
			//	//cout<<"cannot get the transform matrix!!"<<endl<<endl;
			//	//framecounter=0;
			//	//continue;
			//}
			
			//
			
			cvShowImage("projector_adjust",frame_video);
			//cvWriteFrame( writer1, frame_camera );
			cvWriteFrame( writer2, frame_video );

			//	swap = processShowframe(image);//处理边框  变为黑色
			////adjust current frame_camera to erase the tremble
			////cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
			////cvShowImage("adjusted",frame_camera);
			////cvShowImage("original_marker",featuredFrame);

			////addMarker(&image);
			////Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
			////Mat show(image,CV_8UC3);
	
			//double finish=clock();
			////printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	
			////IplImage* result;
			//
			////cvShowImage("projector_marker",frame_video);

			////cvWriteFrame( writer1, testframe); 
			////cvWriteFrame( writer1, frame_camera );
			//// cvWriteFrame( writer2, result );
			//double start=clock();
		
			//	for(iter=features4.begin();iter != features4.end();iter++){
			//	
			//		cvCircle( featuredFrame, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);
			//	
			//		//cout<<"feature point "<<*iter<<" "<<endl;

			//		double dx=initpoints[*iter].x-points[1][*iter].x;
			//		double dy=initpoints[*iter].y-points[1][*iter].y;

			//		double ddx=points[0][*iter].x-points[1][*iter].x;
			//		double ddy=points[0][*iter].y-points[1][*iter].y;
			//	
			//		//cout<<"deltax="<<ddx<<"  deltay="<<ddy<<endl;
			//		if(ddx<20 || ddy<20){
			//			delx+=dx;
			//			dely+=dy;
			//			reduced_features.push_back(*iter);
			//		}
			//	}

			//	static int s=0, s1 = 0, s2 = 0;
			//	//printf("s = %d\n",s);
			//	Mat trans_mat=getTransMat(initpoints,points[1],reduced_features);
			//	if(trans_mat.rows==0){
			//		cout<<"cannot get the transform matrix!!"<<endl<<endl;
			//		framecounter=0;
			//		continue;
			//	}
			//	CvMat warp_mat = trans_mat;
			//	//printf("s1 = %d\n",s1);
			//	//printf("trans_mat's size=%d\n",trans_mat.rows);
			//	cvWarpAffine( frame_video, image, &warp_mat );  //对图像做仿射变换
			//	//printf("s2 = %d\n",s2);
			//	swap = processShowframe(image);//处理边框  变为黑色
			//
			//	reduced_features.clear();

			////adjust current frame_camera to erase the tremble
			////cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
			////cvShowImage("adjusted",frame_camera);
			//cvShowImage("original_marker",featuredFrame);
			////if(framecounter%2==0){
			////Mat show=adjustFrame(image,delx,dely);
			////printf("deltax=%f   deltay=%f \n",delx,dely);	
			//addMarker(&image);
			////Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
			//Mat show(image,CV_8UC3);
		
			//delx=0;dely=0;
		
			//double finish=clock();
			////printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	
			//IplImage* result;
			//DrawPictureToHDC(frame_camera,IDC_ShowFrame);
			//cvShowImage("projector_marker",result);
			//cvWriteFrame( writer1, testframe); 
			//cvWriteFrame( writer1, frame_camera );
			// cvWriteFrame( writer2, result );
			//}
			//ShowAdjustedFrame("Adjusted",frame_camera,delx,dely );
			char c = cvWaitKey(10);
			if(c == 27 )
				return;		

		}//end for
	}//end button clicked
}//end function

void marker_based_deshake_rect(){

	// TODO: Add your command handler code here
	CString FilePathName;
	char* path;
	CFileDialog dlg(TRUE, //TRUE为OPEN对话框，FALSE为SAVE AS对话框
		NULL, 
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		(LPCTSTR)_TEXT("MTS Files (*.MTS)|*.MTS|All Files (*.*)|*.*||"),
		NULL);

	if(dlg.DoModal()==IDOK)
	{
		FilePathName=dlg.GetPathName(); //文件名保存在了FilePathName里
		//path=(LPSTR)(LPCTSTR)FilePathName;
		std:string _path = FilePathName.GetBuffer(0);;
		//path=FilePathName.GetBuffer(0);
		//CString strMsg=_T("当前文件打开路径为：\n")+FilePathName;//测试用的 可以删掉
		//MessageBox(strMsg);//测试用的 可以删掉
		//printf("file path%s",path);
		cvNamedWindow("binary_marker",0);
		cvNamedWindow("projector_marker",0);
		cvNamedWindow("projector_adjust",0);
		IplImage  *featuredFrame=0,*image=0,*swap=0;
		int win_size = 10;
		
		double delx=0,dely=0;//偏移向量
		vector<int> features4,reduced_features;
		vector<int>::iterator iter;
		vector<Point>initMarkers,capturedMarkers;
		
		char image_name[25];  
		//IplImage* bg=cvCreateImage(cvSize(GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)),IPL_DEPTH_8U,1);
		//cvNamedWindow("Adjusted",CV_WINDOW_FULLSCREEN);
		//cvShowImage("Adjusted",bg);
		//char* path="4-1.MTS";
		CvCapture* capture = cvCreateFileCapture(_path.c_str());//为视频文件分配内存空间  projector2投影仪
		
		CvCapture* capture2 = cvCaptureFromCAM(0);
		int init=0;
		char cc;
		if( !capture2 )
		{
			fprintf(stderr,"Could not initialize capturing...\n");
			return;
		}
		/*初始化写视频*/
		double fps = 20;/*cvGetCaptureProperty (
		capture,
		CV_CAP_PROP_FPS);*/

		CvSize size = cvSize((int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH),
		(int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT)
		);

		CvVideoWriter* writer1=cvCreateVideoWriter(
		"original.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		CvVideoWriter* writer2=cvCreateVideoWriter(
		"adjusted.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		IplImage* frame_video=0,*frame_camera=0,*binary_video;
		for(int framecounter=0;;framecounter++)
		{
			frame_video = cvQueryFrame( capture );
			binary_video=cvCloneImage(frame_video);
			//addMarker_rect(&frame_video);
			cvShowImage("projector_marker",frame_video);
			if(!frame_video)
				return;
			
			if(!init){
				cout<<"please adjusted the image to be projected.....  ";
				cout<<"press 'a'  to start"<<endl;
			    cc=waitKey(0);
				if(cc=='a'){
					cout<<"start capture..."<<endl;
					init=1;
				}
			}

			frame_camera= cvQueryFrame(capture2);
			//cvShowImage("original_marker",frame_video);

			/*1st camera frame 
			  find the initial markers; initilize the captured markers */
			if(init==1 && framecounter==0){
				cout<<"finding the 1st markers from the frame_camera"<<endl;				
				initMarkers=findMarkers_rect(binary_video);
				capturedMarkers=initMarkers;
				cvSaveImage("init.jpg",binary_video,0);
				cvSaveImage("real.jpg",frame_video,0);
				
			}
			else{
				capturedMarkers=findMarkers_rect(binary_video);
			}

			//显示4 marker
			if( (capturedMarkers[0].x==0 && capturedMarkers[0].y==0) || (capturedMarkers[1].x==0 && capturedMarkers[1].y==0) || 
				(capturedMarkers[2].x==0 && capturedMarkers[2].y==0) || (capturedMarkers[3].x==0 && capturedMarkers[3].y==0)
				)
			{
				//cout<<"marker point==0....program terminate"<<endl;
				continue;
			}
				

			for(int i=0;i<capturedMarkers.size();i++){
				cout<<capturedMarkers[i].x<<" " <<capturedMarkers[i].y<<endl;
				cvCircle( frame_video, CvPoint(capturedMarkers[i]), 3, CV_RGB(0,255,0), -1, 8,0);
				cvCircle( binary_video, CvPoint(capturedMarkers[i]), 3, CV_RGB(0,255,0), -1, 8,0);
			}

			cvShowImage("projector_marker",frame_video);
			cvShowImage("binary_marker",binary_video);
			cvWriteFrame( writer1, frame_video); 
			
			if(initMarkers.size()==4 && capturedMarkers.size()==4){
				Mat tranMat=get_tsr_matrix(capturedMarkers,initMarkers);
				CvMat warp_mat = tranMat;
				cvWarpAffine( frame_video, frame_video, &warp_mat );  //对图像做仿射变换
				
				cvWriteFrame( writer2, frame_video );
			}
			else{
				cout<<"markers not found "<<endl;
				continue;
			}
			//	
			//if(tranMat.rows==0){
			//	//cout<<"cannot get the transform matrix!!"<<endl<<endl;
			//	//framecounter=0;
			//	//continue;
			//}
			
			//
			
			cvShowImage("projector_adjust",frame_video);

			//	swap = processShowframe(image);//处理边框  变为黑色
			////adjust current frame_camera to erase the tremble
			////cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
			////cvShowImage("adjusted",frame_camera);
			////cvShowImage("original_marker",featuredFrame);

			////addMarker(&image);
			////Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
			////Mat show(image,CV_8UC3);
	
			//double finish=clock();
			////printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	
			////IplImage* result;
			//
			////cvShowImage("projector_marker",frame_video);

			////cvWriteFrame( writer1, testframe); 
			////cvWriteFrame( writer1, frame_camera );
			//// cvWriteFrame( writer2, result );
			//double start=clock();
		
			//	for(iter=features4.begin();iter != features4.end();iter++){
			//	
			//		cvCircle( featuredFrame, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);
			//	
			//		//cout<<"feature point "<<*iter<<" "<<endl;

			//		double dx=initpoints[*iter].x-points[1][*iter].x;
			//		double dy=initpoints[*iter].y-points[1][*iter].y;

			//		double ddx=points[0][*iter].x-points[1][*iter].x;
			//		double ddy=points[0][*iter].y-points[1][*iter].y;
			//	
			//		//cout<<"deltax="<<ddx<<"  deltay="<<ddy<<endl;
			//		if(ddx<20 || ddy<20){
			//			delx+=dx;
			//			dely+=dy;
			//			reduced_features.push_back(*iter);
			//		}
			//	}

			//	static int s=0, s1 = 0, s2 = 0;
			//	//printf("s = %d\n",s);
			//	Mat trans_mat=getTransMat(initpoints,points[1],reduced_features);
			//	if(trans_mat.rows==0){
			//		cout<<"cannot get the transform matrix!!"<<endl<<endl;
			//		framecounter=0;
			//		continue;
			//	}
			//	CvMat warp_mat = trans_mat;
			//	//printf("s1 = %d\n",s1);
			//	//printf("trans_mat's size=%d\n",trans_mat.rows);
			//	cvWarpAffine( frame_video, image, &warp_mat );  //对图像做仿射变换
			//	//printf("s2 = %d\n",s2);
			//	swap = processShowframe(image);//处理边框  变为黑色
			//
			//	reduced_features.clear();

			////adjust current frame_camera to erase the tremble
			////cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
			////cvShowImage("adjusted",frame_camera);
			//cvShowImage("original_marker",featuredFrame);
			////if(framecounter%2==0){
			////Mat show=adjustFrame(image,delx,dely);
			////printf("deltax=%f   deltay=%f \n",delx,dely);	
			//addMarker(&image);
			////Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
			//Mat show(image,CV_8UC3);
		
			//delx=0;dely=0;
		
			//double finish=clock();
			////printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	
			//IplImage* result;
			//DrawPictureToHDC(frame_camera,IDC_ShowFrame);
			//cvShowImage("projector_marker",result);
			//cvWriteFrame( writer1, testframe); 
			//cvWriteFrame( writer1, frame_camera );
			// cvWriteFrame( writer2, result );
			//}
			//ShowAdjustedFrame("Adjusted",frame_camera,delx,dely );
			char c = cvWaitKey(10);
			if(c == 27 )
				return;		

		}//end for
	}//end button clicked
}//end function

//void testMatlab(){
//	Engine *ep;
//	if (!(ep = engOpen(NULL)))
//	{
//		fprintf(stderr, "\nCan't start MATLAB engine\n");
//		return;
//	}
//	int Nsample = 50;
//	const double PI = 3.1415926;
//
//	double *t = new double[Nsample] ;
//	for(int i = 0; i < Nsample; i++)
//	{
//	t[i] = i * 2 * PI / Nsample;
//
//	}
//
//	mxArray *T = NULL, *result = NULL;
//	T = mxCreateDoubleMatrix(1, Nsample, mxREAL);
//	memcpy((void *)mxGetPr(T), (void *)t, Nsample*sizeof(t[0]));
//
//	engPutVariable(ep, "T", T);
//	engEvalString(ep, "Y=sin(T);");
//	engEvalString(ep, "plot(T,Y);");
//	engEvalString(ep, "title('y=sin(t)');");
//	engEvalString(ep, "xlabel('t');");
//	engEvalString(ep, "ylabel('y');");
//
//	printf("Hit return to continue\n\n");
//	fgetc(stdin);
//
//	mxDestroyArray(T);
//	engEvalString(ep, "close;");
//	engClose(ep);
//	return;
//}

void marker_based_deshake_cross(){

	// TODO: Add your command handler code here
	CString FilePathName;
	char* path;
	CFileDialog dlg(TRUE, //TRUE为OPEN对话框，FALSE为SAVE AS对话框
		NULL, 
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		(LPCTSTR)_TEXT("MTS Files (*.MTS)|*.MTS|All Files (*.*)|*.*||"),
		NULL);

	if(dlg.DoModal()==IDOK)
	{
		FilePathName=dlg.GetPathName(); //文件名保存在了FilePathName里
		//path=(LPSTR)(LPCTSTR)FilePathName;
		std:string _path = FilePathName.GetBuffer(0);;
		//path=FilePathName.GetBuffer(0);
		//CString strMsg=_T("当前文件打开路径为：\n")+FilePathName;//测试用的 可以删掉
		//MessageBox(strMsg);//测试用的 可以删掉
		//printf("file path%s",path);
		cvNamedWindow("binary_marker",0);
		cvNamedWindow("projector_marker",0);
		cvNamedWindow("projector_adjust",0);
		IplImage  *featuredFrame=0,*image=0,*swap=0;
		int win_size = 10;
		
		double delx=0,dely=0;//偏移向量
		vector<int> features4,reduced_features;
		vector<int>::iterator iter;
		vector<Point>initMarkers,capturedMarkers;
		
		char image_name[25];  
		//IplImage* bg=cvCreateImage(cvSize(GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN)),IPL_DEPTH_8U,1);
		//cvNamedWindow("Adjusted",CV_WINDOW_FULLSCREEN);
		//cvShowImage("Adjusted",bg);
		//char* path="4-1.MTS";
		CvCapture* capture = cvCreateFileCapture(_path.c_str());//为视频文件分配内存空间  projector2投影仪
		
		CvCapture* capture2 = cvCaptureFromCAM(0);
		int init=0;
		char cc;
		if( !capture2 )
		{
			fprintf(stderr,"Could not initialize capturing...\n");
			return;
		}
		/*初始化写视频*/
		double fps = 20;/*cvGetCaptureProperty (
		capture,
		CV_CAP_PROP_FPS);*/

		CvSize size = cvSize((int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH),
		(int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT)
		);

		CvVideoWriter* writer1=cvCreateVideoWriter(
		"original.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		CvVideoWriter* writer2=cvCreateVideoWriter(
		"adjusted.avi",/*filename*/
		CV_FOURCC('P','I','M','1'), fps,size,1);	// 写视频文件
	
		IplImage* frame_video=0,*frame_camera=0,*binary_video;
		for(int framecounter=0;;framecounter++)
		{
			frame_video = cvQueryFrame( capture );
			
			if(!frame_video){
				cout<<"end.."<<endl;
				return;
			}
			binary_video=cvCloneImage(frame_video);
			//addMarker_cross(&frame_video);
			cvShowImage("projector_marker",frame_video);

			if(!init){
				cout<<"please adjusted the image to be projected.....  ";
				cout<<"press 'a'  to start"<<endl;
			    cc=waitKey(0);
				if(cc=='a'){
					cout<<"start capture..."<<endl;
					init=1;
				}
			}

			frame_camera= cvQueryFrame(capture2);
			//cvShowImage("original_marker",frame_video);

			/*1st camera frame 
			  find the initial markers; initilize the captured markers */
			if(init==1 && framecounter==0){
				cout<<"finding the 1st markers from the frame_camera"<<endl;				
				initMarkers=findMarkers_cross(binary_video);
				capturedMarkers=initMarkers;
				cvSaveImage("init.jpg",binary_video,0);
			}
			else{
				capturedMarkers=findMarkers_cross(binary_video);
			}

			//显示4 marker
			if( (capturedMarkers[0].x==0 && capturedMarkers[0].y==0) || (capturedMarkers[1].x==0 && capturedMarkers[1].y==0) || 
				(capturedMarkers[2].x==0 && capturedMarkers[2].y==0) || (capturedMarkers[3].x==0 && capturedMarkers[3].y==0)
				)
			{
				//cout<<"marker point==0....program terminate"<<endl;
				continue;
			}
				

			for(int i=0;i<capturedMarkers.size();i++){
				//cout<<capturedMarkers[i].x<<" " <<capturedMarkers[i].y<<endl;
				cvCircle( frame_video, CvPoint(capturedMarkers[i]), 1, CV_RGB(0,255,0), -1, 8,0);
				//cvCircle( binary_video, CvPoint(capturedMarkers[i]), 1, CV_RGB(0,255,0), -1, 8,0);
			}
			
			/*marked the find points ->captured markers should be m1,m2,m3 or m4, to modify function findMarkers_cross's return type*/
			//markCrossPoint(frame_video,capturedMarkers);

			cvShowImage("projector_marker",frame_video);
			cvShowImage("binary_marker",binary_video);
			cvWriteFrame( writer1, frame_video); 
			/*show all captured points*/
			//cvSaveImage("marker.jpg",frame_video,0);
			//cv::waitKey();
			if(initMarkers.size()==4 && capturedMarkers.size()==4){
				Mat tranMat=get_tsr_matrix(capturedMarkers,initMarkers);
				CvMat warp_mat = tranMat;
				cvWarpAffine( frame_video, frame_video, &warp_mat );  //对图像做仿射变换
				
				cvWriteFrame( writer2, frame_video );
			}
			else{
				//cout<<"markers not found "<<endl;
				continue;
			}
			//	
			//if(tranMat.rows==0){
			//	//cout<<"cannot get the transform matrix!!"<<endl<<endl;
			//	//framecounter=0;
			//	//continue;
			//}
			
			cvReleaseImage(&binary_video);
			cvShowImage("projector_adjust",frame_video);

			//	swap = processShowframe(image);//处理边框  变为黑色
			////adjust current frame_camera to erase the tremble
			////cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
			////cvShowImage("adjusted",frame_camera);
			////cvShowImage("original_marker",featuredFrame);

			////addMarker(&image);
			////Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
			////Mat show(image,CV_8UC3);
	
			//double finish=clock();
			////printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	
			////IplImage* result;
			//
			////cvShowImage("projector_marker",frame_video);

			////cvWriteFrame( writer1, testframe); 
			////cvWriteFrame( writer1, frame_camera );
			//// cvWriteFrame( writer2, result );
			//double start=clock();
		
			//	for(iter=features4.begin();iter != features4.end();iter++){
			//	
			//		cvCircle( featuredFrame, cvPointFrom32f(points[1][*iter]), 3, CV_RGB(0,255,0), -1, 8,0);
			//	
			//		//cout<<"feature point "<<*iter<<" "<<endl;

			//		double dx=initpoints[*iter].x-points[1][*iter].x;
			//		double dy=initpoints[*iter].y-points[1][*iter].y;

			//		double ddx=points[0][*iter].x-points[1][*iter].x;
			//		double ddy=points[0][*iter].y-points[1][*iter].y;
			//	
			//		//cout<<"deltax="<<ddx<<"  deltay="<<ddy<<endl;
			//		if(ddx<20 || ddy<20){
			//			delx+=dx;
			//			dely+=dy;
			//			reduced_features.push_back(*iter);
			//		}
			//	}

			//	static int s=0, s1 = 0, s2 = 0;
			//	//printf("s = %d\n",s);
			//	Mat trans_mat=getTransMat(initpoints,points[1],reduced_features);
			//	if(trans_mat.rows==0){
			//		cout<<"cannot get the transform matrix!!"<<endl<<endl;
			//		framecounter=0;
			//		continue;
			//	}
			//	CvMat warp_mat = trans_mat;
			//	//printf("s1 = %d\n",s1);
			//	//printf("trans_mat's size=%d\n",trans_mat.rows);
			//	cvWarpAffine( frame_video, image, &warp_mat );  //对图像做仿射变换
			//	//printf("s2 = %d\n",s2);
			//	swap = processShowframe(image);//处理边框  变为黑色
			//
			//	reduced_features.clear();

			////adjust current frame_camera to erase the tremble
			////cout<<"position x:"<<points[1][20].x<<"  y:"<<points[1][20].y<<endl;
			////cvShowImage("adjusted",frame_camera);
			//cvShowImage("original_marker",featuredFrame);
			////if(framecounter%2==0){
			////Mat show=adjustFrame(image,delx,dely);
			////printf("deltax=%f   deltay=%f \n",delx,dely);	
			//addMarker(&image);
			////Mat show=adjustFrame(frame_camera,delx/features4.size(),dely/features4.size());
			//Mat show(image,CV_8UC3);
		
			//delx=0;dely=0;
		
			//double finish=clock();
			////printf("deltax=%f   deltay=%f and the timeconsume is%f\n",delx,dely,(finish-start)/CLOCKS_PER_SEC);	
			//IplImage* result;
			//DrawPictureToHDC(frame_camera,IDC_ShowFrame);
			//cvShowImage("projector_marker",result);
			//cvWriteFrame( writer1, testframe); 
			//cvWriteFrame( writer1, frame_camera );
			// cvWriteFrame( writer2, result );
			//}
			//ShowAdjustedFrame("Adjusted",frame_camera,delx,dely );
			char c = cvWaitKey(10);
			if(c == 27 )
				return;		

		}//end for

		cvReleaseCapture(&capture);
		cvReleaseCapture(&capture2);
		cvReleaseImage(&frame_camera);
		cvReleaseImage(&frame_video);
		cvReleaseVideoWriter(&writer1);
		cvReleaseVideoWriter(&writer2);
		
	}//end button clicked
}//end function

void CShakingSolutionDlg::OnBnClickedMe()
	
{   /*feature_based_deshake();
	以前动态寻找特征点 进行调整投影仪方法*/	
	//feature_based_deshake();

	/*加入四个marker点，摄像头捕捉marker，检测marker点，调整投影仪投影帧方法*/
	//marker_based_deshake_circle();

	//矩形特征点 确定marker点
	//marker_based_deshake_rect();
	
	//调用matlab 实验代码
	//testMatlab();
	//十字叉匹配 减少误差
	marker_based_deshake_cross();

}//end function